# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`wls_install`](#wls_install): This class activates the basic setuo activities for using the other functional `wls_install` classes and defined types.
* [`wls_install::clear_caches`](#wls_installclear_caches): This class contains the puppet code that implements the default facter cache invainvalidationlidatin rules.
* [`wls_install::fact_caching`](#wls_installfact_caching): This class ensure's that the wls_install facts that can be cached, are cached with the correct settings.
* [`wls_install::ords`](#wls_installords): Class for install and config Oracle ORDS software.
* [`wls_install::ords::software`](#wls_installordssoftware): This defined type allows you to install ords software.
* [`wls_install::software`](#wls_installsoftware): wls_install::software  This class allows you install the WebLogic software on your system. Here is an example on how you could use this:```cl
* [`wls_install::support::files`](#wls_installsupportfiles): Support class ensuring neccecary files.
* [`wls_install::support::params`](#wls_installsupportparams): Support class ensuring neccecary params.
* [`wls_install::urandomfix`](#wls_installurandomfix): This class installs the urandom fix for Java.

### Defined types

* [`wls_install::cluster_node`](#wls_installcluster_node): Type setting up machine as a cluster node.
* [`wls_install::control`](#wls_installcontrol): This defined type allows you to control a admin server or a managed server during s Puppet run.
* [`wls_install::copydomain`](#wls_installcopydomain): This defined type allows you copy a domain to an other WebLogic node.
* [`wls_install::domain`](#wls_installdomain): This defined type allows you create a WebLogic domain.
* [`wls_install::fmw`](#wls_installfmw): wls_install::fmw  This defined type allows you to install the Fusion Middleware add-on software. It supports:- OSB- SOA Suite- WebTier (HTTP 
* [`wls_install::fmwlogdir`](#wls_installfmwlogdir): This defined type allows you change a log folder location of a FMW server.
* [`wls_install::increased_memory_bsu`](#wls_installincreased_memory_bsu): wls_install::increased_memory_bsu  Patches the BSU utility to increase the amount of memory available for patches.  See the file "LICENSE" fo
* [`wls_install::managed_server`](#wls_installmanaged_server): Type defined for setting up managed server.
* [`wls_install::nodemanager`](#wls_installnodemanager): This defined type allows you to start a nodemanager on a system.
* [`wls_install::opatchupgrade`](#wls_installopatchupgrade): This defined type allows you to install specified opatch version.
* [`wls_install::ords::config`](#wls_installordsconfig): This defined type allows you to set specified ords configuration version
* [`wls_install::ords::software_version`](#wls_installordssoftware_version): This defined type allows you to install specified version of ords software.
* [`wls_install::packdomain`](#wls_installpackdomain): wls_install::packdomain  This defined type allows you pack the definition of your domain into a file. Using ora_install::copydomain, you can 
* [`wls_install::software_version`](#wls_installsoftware_version): This defined type allows you install the WebLogic software on your system.
* [`wls_install::storeuserconfig`](#wls_installstoreuserconfig): This defined type allows you to create a user config for WLST , this way you don't need to know the weblogic password.
* [`wls_install::support::nodemanagerautostart`](#wls_installsupportnodemanagerautostart): wls_install::support::nodemanagerautostart  This defined type allows you to add the nodemanager startup scripts to the system. Here is an exa
* [`wls_install::utils::fmwcluster`](#wls_installutilsfmwcluster): This defined type allows you to convert an existing cluster into a OSB or SOA suite cluster (BPM is optional) and also convert BAM to a BAM cluster.
* [`wls_install::utils::fmwclusterjrf`](#wls_installutilsfmwclusterjrf): This defined type allows you to convert an existing cluster into an ADF/JRF cluster.
* [`wls_install::utils::forms11gpatch`](#wls_installutilsforms11gpatch): Type installing forms11gpatch.
* [`wls_install::utils::oimconfig`](#wls_installutilsoimconfig): wls_install::utils::oimconfig  This defined type allows you to configure OIM , oim server, design or remote configuration. Here is an example
* [`wls_install::utils::orainst`](#wls_installutilsorainst): See the file "LICENSE" for the full license governing this code.  == define: wls_install::utils::orainst   creates oraInst.loc for oracle pro
* [`wls_install::utils::private::old_servers_removed`](#wls_installutilsprivateold_servers_removed): See the file "LICENSE" for the full license governing this code.   This defined type removes all directoryes in the domain that once belonged
* [`wls_install::utils::rcu`](#wls_installutilsrcu): This is a private class.
* [`wls_install::utils::webtier`](#wls_installutilswebtier): This defined type allows you to add an OHS instance to a WebLogic Domain and in the Enterprise Manager, optional with OHS OAM Webgate.

### Resource types

* [`wls_adminserver`](#wls_adminserver): control the adminserver state like running,stop,restart
* [`wls_directory_structure`](#wls_directory_structure): add all the directories needed by the oracle weblogic installation

### Functions

* [`wls_install::artifact_exists`](#wls_installartifact_exists): This function checks if artifact exists in the specified location.   See the file "LICENSE" for the full license governing this code.
* [`wls_install::bam_cluster_configured`](#wls_installbam_cluster_configured): This function checks if bam cluster is configured in the specified path.   See the file "LICENSE" for the full license governing this code.
* [`wls_install::domain_exists`](#wls_installdomain_exists): This function checks if domain exists in the specified location.   See the file "LICENSE" for the full license governing this code.
* [`wls_install::filter_unsupported_jvm_options`](#wls_installfilter_unsupported_jvm_options): This function filters unsupported jvm options.   See the file "LICENSE" for the full license governing this code.
* [`wls_install::fmw_installed`](#wls_installfmw_installed): Check if the Fusion Middleware product is already installed
* [`wls_install::jrf_cluster_configured`](#wls_installjrf_cluster_configured): This function checks if osb cluster is configured in the specified path.   See the file "LICENSE" for the full license governing this code.
* [`wls_install::log`](#wls_installlog): This function logs data from wls_install module.   See the file "LICENSE" for the full license governing this code.
* [`wls_install::oim_configured`](#wls_installoim_configured): This function checks if oim is configured in the specified path.   See the file "LICENSE" for the full license governing this code.
* [`wls_install::ords_installed`](#wls_installords_installed): This function checks if ORDS is installed.   See the file "LICENSE" for the full license governing this code.
* [`wls_install::osb_cluster_configured`](#wls_installosb_cluster_configured): This function checks if osb cluster is configured in the specified path.   See the file "LICENSE" for the full license governing this code.
* [`wls_install::running_domains`](#wls_installrunning_domains): This function will return the domains currently running from a specific home.   See the file "LICENSE" for the full license governing this co
* [`wls_install::soa_cluster_configured`](#wls_installsoa_cluster_configured): This function checks if soa cluster is configured in the specified path.   See the file "LICENSE" for the full license governing this code.
* [`wls_install::weblogic_exists`](#wls_installweblogic_exists): This function checks if WebLogic is installed.   See the file "LICENSE" for the full license governing this code.
* [`wls_install::wls_patches_missing`](#wls_installwls_patches_missing): This function checks if the specfied patches are installed. And it will return a Hash with the oracle home(s) with patch details that still n
* [`wls_install::wls_physical_patches`](#wls_installwls_physical_patches): This function parses a Hash of patches and looks for resources with sub_patches. If they are there, this function will translate it to the ac

### Data types

* [`Wls_install::Fmw_products`](#wls_installfmw_products): Installed fmw products.   See the file "LICENSE" for the full license governing this code.
* [`Wls_install::Versions`](#wls_installversions): Versions of installed WebLogic software.   See the file "LICENSE" for the full license governing this code.

## Classes

### <a name="wls_install"></a>`wls_install`

wls_install::wls_install

At this point in time it applies the setup for fact caching.


See the file "LICENSE" for the full license governing this code.

### <a name="wls_installclear_caches"></a>`wls_install::clear_caches`

wls_install::clear_caches

Whenever a certain set of Puppet classes or defined types is applied, it will clear the facter caches for those facts that are implemented.


See the file "LICENSE" for the full license governing this code.

### <a name="wls_installfact_caching"></a>`wls_install::fact_caching`

wls_install::fact_caching

You can change all TTL settings for the facts if an other setting is more fitting for your setup.

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `wls_install::fact_caching` class:

* [`enabled`](#enabled)
* [`product_version_ttl`](#product_version_ttl)
* [`opatch_version_ttl`](#opatch_version_ttl)
* [`installed_features_ttl`](#installed_features_ttl)
* [`running_domains_ttl`](#running_domains_ttl)
* [`installed_patches_ttl`](#installed_patches_ttl)
* [`wls_install_inventory_loc_ttl`](#wls_install_inventory_loc_ttl)
* [`wls_install_domains_ttl`](#wls_install_domains_ttl)
* [`ords_homes_ttl`](#ords_homes_ttl)

##### <a name="enabled"></a>`enabled`

Data type: `Boolean`

When set to true, this enables facter caching for the wls_install module facts.
Beware that you need to have Facter version 4.1.0 or higher to enabled this. When you set this value to true, automatically TTL settings for most of the wls_install facts are set to a default value. For most installations, the default settings are fine.
When you set this value to `true`, the [facter setting `force-dot-resolution`](https://tickets.puppetlabs.com/browse/PUP-11089) is enabled. You have to ensure that all of your facts keep on working with this setting.

##### <a name="product_version_ttl"></a>`product_version_ttl`

Data type: `Optional[String[1]]`

The Time to Live for the `wls_install_homes.
product_version` part of the `wls_install_homes` fact.

##### <a name="opatch_version_ttl"></a>`opatch_version_ttl`

Data type: `Optional[String[1]]`

The Time to Live for the `wls_install_homes.
opatch_version` part of the `wls_install_homes` fact.

##### <a name="installed_features_ttl"></a>`installed_features_ttl`

Data type: `Optional[String[1]]`

The Time to Live for the `wls_install_homes.
installed_features` part of the `wls_install_homes` fact.

##### <a name="running_domains_ttl"></a>`running_domains_ttl`

Data type: `Optional[String[1]]`

The Time to Live for the `wls_install_homes.
running_domains` part of the `wls_install_homes` fact.

##### <a name="installed_patches_ttl"></a>`installed_patches_ttl`

Data type: `Optional[String[1]]`

The Time to Live for the `wls_install_homes.
installed_patches` part of the `wls_install_homes` fact.

##### <a name="wls_install_inventory_loc_ttl"></a>`wls_install_inventory_loc_ttl`

Data type: `Optional[String[1]]`

The Time to Live for the `wls_install_inventory_loc` fact.

##### <a name="wls_install_domains_ttl"></a>`wls_install_domains_ttl`

Data type: `Optional[String[1]]`



##### <a name="ords_homes_ttl"></a>`ords_homes_ttl`

Data type: `Optional[String[1]]`

The Time to Live for the `ords_homes` fact.

### <a name="wls_installords"></a>`wls_install::ords`

wls_install::ords

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `wls_install::ords` class:

* [`version`](#version)
* [`source`](#source)
* [`file`](#file)
* [`ords_home`](#ords_home)
* [`db_hostname`](#db_hostname)
* [`db_port`](#db_port)
* [`db_servicename`](#db_servicename)
* [`db_sid`](#db_sid)
* [`db_username`](#db_username)
* [`migrate_apex_rest`](#migrate_apex_rest)
* [`plsql_gateway_add`](#plsql_gateway_add)
* [`rest_services_apex_add`](#rest_services_apex_add)
* [`rest_services_ords_add`](#rest_services_ords_add)
* [`schema_tablespace_default`](#schema_tablespace_default)
* [`schema_tablespace_temp`](#schema_tablespace_temp)
* [`standalone_http_port`](#standalone_http_port)
* [`standalone_static_images`](#standalone_static_images)
* [`user_public_password`](#user_public_password)
* [`user_tablespace_default`](#user_tablespace_default)
* [`user_tablespace_temp`](#user_tablespace_temp)
* [`sys_user`](#sys_user)
* [`sys_password`](#sys_password)
* [`logoutput`](#logoutput)

##### <a name="version"></a>`version`

Data type: `String[1]`

The version that is installed in the used Oracle home.
Puppet uses this value to decide on version specific actions.

##### <a name="source"></a>`source`

Data type: `String[1]`

Source for the operation.

##### <a name="file"></a>`file`

Data type: `String[1]`

The name of the ords install file.

##### <a name="ords_home"></a>`ords_home`

Data type: `Stdlib::Absolutepath`

The ords home path.

##### <a name="db_hostname"></a>`db_hostname`

Data type: `String[1]`

The hostname of the machine where the database is running.

##### <a name="db_port"></a>`db_port`

Data type: `Integer`

The port of the machine where the database is running.

##### <a name="db_servicename"></a>`db_servicename`

Data type: `String[1]`

The name of the service where database is running.

##### <a name="db_sid"></a>`db_sid`

Data type: `String[1]`

The service id of the machine where the database is running.

##### <a name="db_username"></a>`db_username`

Data type: `String[1]`

The name  of the database user.

##### <a name="migrate_apex_rest"></a>`migrate_apex_rest`

Data type: `Boolean`

Flag defining if APEX REST api should be migrated.

##### <a name="plsql_gateway_add"></a>`plsql_gateway_add`

Data type: `Boolean`

Flag defining if plsql gateway should be added to weblogic.

##### <a name="rest_services_apex_add"></a>`rest_services_apex_add`

Data type: `Boolean`

Flag defining if apex rest services should be added to weblogic.

##### <a name="rest_services_ords_add"></a>`rest_services_ords_add`

Data type: `Boolean`

Flag defining if ords rest services should be added to weblogic.

##### <a name="schema_tablespace_default"></a>`schema_tablespace_default`

Data type: `String[1]`

The default tablespace schema.

##### <a name="schema_tablespace_temp"></a>`schema_tablespace_temp`

Data type: `String[1]`

The temporary tablespace schema.

##### <a name="standalone_http_port"></a>`standalone_http_port`

Data type: `Integer`

The standalone http port.

##### <a name="standalone_static_images"></a>`standalone_static_images`

Data type: `Boolean`

The standalone static images.

##### <a name="user_public_password"></a>`user_public_password`

Data type: `String[1]`

The public password of the user.

##### <a name="user_tablespace_default"></a>`user_tablespace_default`

Data type: `String[1]`

The default tablespace of the user.

##### <a name="user_tablespace_temp"></a>`user_tablespace_temp`

Data type: `String[1]`

The temporary tablespace of the user.

##### <a name="sys_user"></a>`sys_user`

Data type: `String[1]`

The system user.

##### <a name="sys_password"></a>`sys_password`

Data type: `String[1]`

The system user password.

##### <a name="logoutput"></a>`logoutput`

Data type: `Variant[Enum['on_failure'], Boolean]`

log the outputs of Puppet exec or not.
When you specify `true` Puppet will log all output of `exec` types.
Valid values are:
- `true`
- `false`
- `on_failure`

Default value: `'on_failure'`

### <a name="wls_installordssoftware"></a>`wls_install::ords::software`

wls_install::ords::software

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `wls_install::ords::software` class:

* [`file`](#file)
* [`ords_home`](#ords_home)
* [`source`](#source)
* [`version`](#version)
* [`logoutput`](#logoutput)

##### <a name="file"></a>`file`

Data type: `String[1]`

The name of the ords install file.

##### <a name="ords_home"></a>`ords_home`

Data type: `Stdlib::Absolutepath`

The ords home path.

##### <a name="source"></a>`source`

Data type: `String[1]`

Source for the operation.

##### <a name="version"></a>`version`

Data type: `String[1]`

The version that is installed in the used Oracle home.
Puppet uses this value to decide on version specific actions.

##### <a name="logoutput"></a>`logoutput`

Data type: `Variant[Enum['on_failure'], Boolean]`

log the outputs of Puppet exec or not.
When you specify `true` Puppet will log all output of `exec` types.
Valid values are:
- `true`
- `false`
- `on_failure`

Default value: `'on_failure'`

### <a name="wls_installsoftware"></a>`wls_install::software`

wls_install::software

This class allows you install the WebLogic software on your system. Here is an example on how you could use this:```class{'ora_install::software':  version              => 1221,                       # 1036|1211|1212|1213|1221  filename             => 'fmw_12.2.1.0.0_wls.jar',   #   jdk_home_dir         => '/usr/java/jdk1.8.0_45',  oracle_base_home_dir => "/opt/oracle",  middleware_home_dir  => "/opt/oracle/middleware12c",  weblogic_home_dir    => "/opt/oracle/middleware12c/wlserver",  os_user              => "oracle",  os_group             => "dba",  download_dir         => "/data/install",  source               => "/vagrant",                 # puppet:///modules/orawls/ | /mnt |  logoutput           => true,}```

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `wls_install::software` class:

* [`version`](#version)
* [`filename`](#filename)
* [`oracle_base_home_dir`](#oracle_base_home_dir)
* [`middleware_home_dir`](#middleware_home_dir)
* [`weblogic_home_dir`](#weblogic_home_dir)
* [`wls_domains_dir`](#wls_domains_dir)
* [`wls_apps_dir`](#wls_apps_dir)
* [`fmw_infra`](#fmw_infra)
* [`jdk_home_dir`](#jdk_home_dir)
* [`os_user`](#os_user)
* [`os_group`](#os_group)
* [`download_dir`](#download_dir)
* [`source`](#source)
* [`java_parameters`](#java_parameters)
* [`temp_directory`](#temp_directory)
* [`logoutput`](#logoutput)
* [`oracle_inventory_dir`](#oracle_inventory_dir)

##### <a name="version"></a>`version`

Data type: `Wls_install::Versions`

The version that is installed in the used Oracle home.
Puppet uses this value to decide on version specific actions.

Default value: `1111`

##### <a name="filename"></a>`filename`

Data type: `String[1]`

The source file to use.

Default value: ``undef``

##### <a name="oracle_base_home_dir"></a>`oracle_base_home_dir`

Data type: `Stdlib::Absolutepath`

A directory to use as Oracle base directory.

Default value: ``undef``

##### <a name="middleware_home_dir"></a>`middleware_home_dir`

Data type: `Stdlib::Absolutepath`

Middleware home directory.

Default value: ``undef``

##### <a name="weblogic_home_dir"></a>`weblogic_home_dir`

Data type: `Optional[Stdlib::Absolutepath]`

Directory to use as WebLogic home.

Default value: ``undef``

##### <a name="wls_domains_dir"></a>`wls_domains_dir`

Data type: `Optional[Stdlib::Absolutepath]`

The root directory where all domain directories reside in.

Default value: ``undef``

##### <a name="wls_apps_dir"></a>`wls_apps_dir`

Data type: `Optional[Stdlib::Absolutepath]`

The root directory where all aplication directories reside in.

Default value: ``undef``

##### <a name="fmw_infra"></a>`fmw_infra`

Data type: `Boolean`

Determine if you want to install Fusion Middleware infra.

Default value: ``false``

##### <a name="jdk_home_dir"></a>`jdk_home_dir`

Data type: `Stdlib::Absolutepath`

The homdirectory for the Java evelopment Kit.

Default value: ``undef``

##### <a name="os_user"></a>`os_user`

Data type: `String[1]`

The os user used to install and run WebLogic.

Default value: ``undef``

##### <a name="os_group"></a>`os_group`

Data type: `String[1]`

The os group used to install and run WebLogic.

Default value: ``undef``

##### <a name="download_dir"></a>`download_dir`

Data type: `Stdlib::Absolutepath`

The directory where the Puppet software puts all downloaded files.
Before Puppet can actually use remote files, they must be downloaded first. Puppet uses this directory to put all files in.
The default value is: `/install`

Default value: ``undef``

##### <a name="source"></a>`source`

Data type: `String[1]`

Source for the operation.

Default value: ``undef``

##### <a name="java_parameters"></a>`java_parameters`

Data type: `Optional[String]`

The (extra) parameters to pass when calling java.

Default value: `''`

##### <a name="temp_directory"></a>`temp_directory`

Data type: `Stdlib::Absolutepath`

Directory to use for temporary files.

Default value: `'/tmp'`

##### <a name="logoutput"></a>`logoutput`

Data type: `Variant[
    Boolean,
    Enum[
      'on_failure'
    ]
  ]`

log the outputs of Puppet exec or not.
When you specify `true` Puppet will log all output of `exec` types.
Valid values are:
- `true`
- `false`
- `on_failure`

Default value: `lookup({name => 'logoutput', default_value => 'on_failure'})`

##### <a name="oracle_inventory_dir"></a>`oracle_inventory_dir`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: ``undef``

### <a name="wls_installsupportfiles"></a>`wls_install::support::files`

wls_install::support::files

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `wls_install::support::files` class:

* [`os_oracle_home`](#os_oracle_home)
* [`ora_inventory`](#ora_inventory)
* [`os_domain_type`](#os_domain_type)
* [`os_log_folder`](#os_log_folder)
* [`os_download_folder`](#os_download_folder)
* [`os_mdw_home`](#os_mdw_home)
* [`os_wl_home`](#os_wl_home)
* [`ora_user`](#ora_user)
* [`ora_group`](#ora_group)
* [`os_domain`](#os_domain)
* [`os_domain_path`](#os_domain_path)
* [`node_mgr_path`](#node_mgr_path)
* [`node_mgr_port`](#node_mgr_port)
* [`node_mgr_address`](#node_mgr_address)
* [`wls_user`](#wls_user)
* [`wls_password`](#wls_password)
* [`wls_adminserver`](#wls_adminserver)
* [`jsse_enabled`](#jsse_enabled)
* [`custom_trust`](#custom_trust)
* [`trust_keystore_file`](#trust_keystore_file)
* [`trust_keystore_passphrase`](#trust_keystore_passphrase)

##### <a name="os_oracle_home"></a>`os_oracle_home`

Data type: `Stdlib::Absolutepath`

A directory to be used as Oracle home directory for this software.

Default value: `$wls_install::support::params::os_oracle_home`

##### <a name="ora_inventory"></a>`ora_inventory`

Data type: `Stdlib::Absolutepath`

The Oracle inventory directory.

Default value: `$wls_install::support::params::ora_inventory`

##### <a name="os_domain_type"></a>`os_domain_type`

Data type: `String[1]`

A domain type to be used for this software.

Default value: `$wls_install::support::params::os_domain_type`

##### <a name="os_log_folder"></a>`os_log_folder`

Data type: `Stdlib::Absolutepath`

A logging directory to be used on this os.

Default value: `$wls_install::support::params::os_log_folder`

##### <a name="os_download_folder"></a>`os_download_folder`

Data type: `Stdlib::Absolutepath`

A download directory to be used on this os.

Default value: `$wls_install::support::params::os_download_folder`

##### <a name="os_mdw_home"></a>`os_mdw_home`

Data type: `Stdlib::Absolutepath`

A middlware home directory to be used on this os.

Default value: `$wls_install::support::params::os_mdw_home`

##### <a name="os_wl_home"></a>`os_wl_home`

Data type: `Stdlib::Absolutepath`

A WebLogic home directory to be used on this os.

Default value: `$wls_install::support::params::os_wl_home`

##### <a name="ora_user"></a>`ora_user`

Data type: `String[1]`

The Oracle user.

Default value: `$wls_install::support::params::ora_user`

##### <a name="ora_group"></a>`ora_group`

Data type: `String[1]`

The Oracle user group.

Default value: `$wls_install::support::params::ora_group`

##### <a name="os_domain"></a>`os_domain`

Data type: `String[1]`

A domain to be used on this os.

Default value: `$wls_install::support::params::os_domain`

##### <a name="os_domain_path"></a>`os_domain_path`

Data type: `Stdlib::Absolutepath`

A domain path to be used on this os.

Default value: `$wls_install::support::params::os_domain_path`

##### <a name="node_mgr_path"></a>`node_mgr_path`

Data type: `Stdlib::Absolutepath`

The nodemanager path.

Default value: `$wls_install::support::params::node_mgr_path`

##### <a name="node_mgr_port"></a>`node_mgr_port`

Data type: `Integer`

The nodemanager port.

Default value: `$wls_install::support::params::node_mgr_port`

##### <a name="node_mgr_address"></a>`node_mgr_address`

Data type: `String[1]`

The nodemanager address.

Default value: `$wls_install::support::params::node_mgr_address`

##### <a name="wls_user"></a>`wls_user`

Data type: `String[1]`

The WebLogic user.

Default value: `$wls_install::support::params::wls_user`

##### <a name="wls_password"></a>`wls_password`

Data type: `Easy_type::Password`

The WebLogic users password.

Default value: `$wls_install::support::params::wls_password`

##### <a name="wls_adminserver"></a>`wls_adminserver`

Data type: `String[1]`

The WebLogic adminserver.

Default value: `$wls_install::support::params::wls_adminserver`

##### <a name="jsse_enabled"></a>`jsse_enabled`

Data type: `Boolean`

Determine if you want to enable JSSE security.

Default value: `$wls_install::support::params::jsse_enabled`

##### <a name="custom_trust"></a>`custom_trust`

Data type: `Boolean`

Determine if you want to use a custom trust or not.

Default value: ``false``

##### <a name="trust_keystore_file"></a>`trust_keystore_file`

Data type: `Optional[String[1]]`

File specificiation of the trust keystore.

Default value: ``undef``

##### <a name="trust_keystore_passphrase"></a>`trust_keystore_passphrase`

Data type: `Optional[Easy_type::Password]`

Passphrase to use for the trust keystore.

Default value: ``undef``

### <a name="wls_installsupportparams"></a>`wls_install::support::params`

wls_install::support::params

See the file "LICENSE" for the full license governing this code.

### <a name="wls_installurandomfix"></a>`wls_install::urandomfix`

wls_install::urandomfix

On Linux low entropy can cause certain operations to be very slow.
Encryption operations need entropy to ensure randomness. Entropy is
generated by the OS when you use the keyboard, the mouse or the disk.

If an encryption operation is missing entropy it will wait until
enough is generated. Which can slow down your system.

To fix this, there are three options:

- use rngd service (this class)
- set java.security in JDK ( jre/lib/security )
- set -Djava.security.egd=file:/dev/./urandom param

To use the rng service, just add:

```puppet
include wls_install::urandomfix
```

to your manifest.


See the file "LICENSE" for the full license governing this code.

## Defined types

### <a name="wls_installcluster_node"></a>`wls_install::cluster_node`

wls_install::cluster_node

Here is an example on how to use it:

``` puppet
}
```

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `wls_install::cluster_node` defined type:

* [`machine_name`](#machine_name)
* [`listenaddress`](#listenaddress)
* [`ssl_listen_port`](#ssl_listen_port)
* [`nodemanager_port`](#nodemanager_port)
* [`server_arguments`](#server_arguments)
* [`listen_port`](#listen_port)
* [`domain_name`](#domain_name)

##### <a name="machine_name"></a>`machine_name`

Data type: `String[1]`

Name of the weblogic machine to use.

##### <a name="listenaddress"></a>`listenaddress`

Data type: `String[1]`

The address to use for listening.
Mat be a physical IP address or a DNS name.

##### <a name="ssl_listen_port"></a>`ssl_listen_port`

Data type: `Integer`

SSL listen port to use.

##### <a name="nodemanager_port"></a>`nodemanager_port`

Data type: `Integer`

The IP port the nodemanager is listening on.

##### <a name="server_arguments"></a>`server_arguments`

Data type: `Array`

Java argcuments to use when starting the managed server.

##### <a name="listen_port"></a>`listen_port`

Data type: `Integer`



##### <a name="domain_name"></a>`domain_name`

Data type: `String[1]`



### <a name="wls_installcontrol"></a>`wls_install::control`

wls_install::control

It allows you to stop, start or restart a managed server. Here is an example on how you could use this:

```puppet
ora_install::control{'startWLSAdminServer12c':
  domain_name                 => "Wls12c",
  server_type                 => 'admin',  # admin|managed
  target                      => 'Server', # Server|Cluster
  server                      => 'AdminServer',
  action                      => 'start',
  weblogic_home_dir           => "/opt/oracle/middleware12c/wlserver",
  jdk_home_dir                => "/usr/java/jdk1.7.0_45",
  weblogic_user               => "weblogic",
  weblogic_password           => "weblogic1",
  adminserver_address         => 'localhost',
  adminserver_port            => 7001,
  nodemanager_port            => 5556,
  nodemanager_secure_listener => true,
  os_user                     => "oracle",
  os_group                    => "dba",
  download_dir                => "/data/install",
}
```

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `wls_install::control` defined type:

* [`middleware_home_dir`](#middleware_home_dir)
* [`weblogic_home_dir`](#weblogic_home_dir)
* [`jdk_home_dir`](#jdk_home_dir)
* [`wls_domains_dir`](#wls_domains_dir)
* [`domain_name`](#domain_name)
* [`server_type`](#server_type)
* [`target`](#target)
* [`server`](#server)
* [`adminserver_address`](#adminserver_address)
* [`adminserver_port`](#adminserver_port)
* [`nodemanager_secure_listener`](#nodemanager_secure_listener)
* [`nodemanager_port`](#nodemanager_port)
* [`action`](#action)
* [`weblogic_user`](#weblogic_user)
* [`weblogic_password`](#weblogic_password)
* [`jsse_enabled`](#jsse_enabled)
* [`custom_trust`](#custom_trust)
* [`trust_keystore_file`](#trust_keystore_file)
* [`trust_keystore_passphrase`](#trust_keystore_passphrase)
* [`os_user`](#os_user)
* [`os_group`](#os_group)
* [`download_dir`](#download_dir)
* [`logoutput`](#logoutput)

##### <a name="middleware_home_dir"></a>`middleware_home_dir`

Data type: `Stdlib::Absolutepath`

Middleware home directory.

Default value: `lookup({name => 'wls_middleware_home_dir'})`

##### <a name="weblogic_home_dir"></a>`weblogic_home_dir`

Data type: `Stdlib::Absolutepath`

Directory to use as WebLogic home.

Default value: `lookup({name => 'wls_weblogic_home_dir'})`

##### <a name="jdk_home_dir"></a>`jdk_home_dir`

Data type: `Stdlib::Absolutepath`

The homdirectory for the Java evelopment Kit.

Default value: `lookup({name => 'wls_jdk_home_dir'})`

##### <a name="wls_domains_dir"></a>`wls_domains_dir`

Data type: `Optional[
    Stdlib::Absolutepath
  ]`

The root directory where all domain directories reside in.

Default value: `lookup({name =>'wls_domains_dir', default_value => undef})`

##### <a name="domain_name"></a>`domain_name`

Data type: `String[1]`

The domain name.

Default value: `lookup({name => 'domain_name'})`

##### <a name="server_type"></a>`server_type`

Data type: `Enum[
    'admin',
    'managed',
    'ohs_standalone'
  ]`

Type of element you want to control:
Valid values are:
- admin
- managed
- ohs_standalone

Default value: `'admin'`

##### <a name="target"></a>`target`

Data type: `Enum[
    'Server',
    'Cluster'
  ]`

Type of target to use:
Valid values are:
 - Server
 - Cluster

Default value: `'Server'`

##### <a name="server"></a>`server`

Data type: `String[1]`

Name of the server you want to control.

Default value: `'AdminServer'`

##### <a name="adminserver_address"></a>`adminserver_address`

Data type: `String[1]`

The address of the admin server.
May be a DNS name or a physical IP address.

Default value: `lookup({name => 'domain_adminserver_address', default_value => 'localhost'})`

##### <a name="adminserver_port"></a>`adminserver_port`

Data type: `Integer`

The IP port the admin server is listening on.

Default value: `lookup({name => 'domain_adminserver_port', default_value => 7001})`

##### <a name="nodemanager_secure_listener"></a>`nodemanager_secure_listener`

Data type: `Boolean`

Use SSL for listening.

Default value: ``true``

##### <a name="nodemanager_port"></a>`nodemanager_port`

Data type: `Integer`

The IP port the nodemanager is listening on.

Default value: `lookup({name => 'domain_nodemanager_port', default_value => 5556})`

##### <a name="action"></a>`action`

Data type: `Enum[
    'start',
    'running',
    'stop',
    'abort'
  ]`

Action to perform.
Valid values:
- start
- running
- stop
- abort

Default value: `'start'`

##### <a name="weblogic_user"></a>`weblogic_user`

Data type: `String[1]`

The base WebLogic username to configure.

Default value: `lookup({name => 'wls_weblogic_user', default_value => 'weblogic'})`

##### <a name="weblogic_password"></a>`weblogic_password`

Data type: `Easy_type::Password`

The password of the base WebLogic user name.

Default value: `lookup({name => 'domain_wls_password'})`

##### <a name="jsse_enabled"></a>`jsse_enabled`

Data type: `Boolean`

Determine if you want to enable JSSE security.

Default value: `lookup({name => 'wls_jsse_enabled', default_value => false})`

##### <a name="custom_trust"></a>`custom_trust`

Data type: `Boolean`

Determine if you want to use a custom trust or not.

Default value: `lookup({name => 'wls_custom_trust', default_value => false})`

##### <a name="trust_keystore_file"></a>`trust_keystore_file`

Data type: `Optional[String[1]]`

File specificiation of the trust keystore.

Default value: `lookup({name => 'wls_trust_keystore_file', default_value => undef})`

##### <a name="trust_keystore_passphrase"></a>`trust_keystore_passphrase`

Data type: `Optional[Easy_type::Password]`

Passphrase to use for the trust keystore.

Default value: `lookup({name => 'wls_trust_keystore_passphrase', default_value => undef})`

##### <a name="os_user"></a>`os_user`

Data type: `String[1]`

The os user used to install and run WebLogic.

Default value: `lookup({name => 'wls_os_user'})`

##### <a name="os_group"></a>`os_group`

Data type: `String[1]`

The os group used to install and run WebLogic.

Default value: `lookup({name => 'wls_os_group'})`

##### <a name="download_dir"></a>`download_dir`

Data type: `Stdlib::Absolutepath`

The directory where the Puppet software puts all downloaded files.
Before Puppet can actually use remote files, they must be downloaded first. Puppet uses this directory to put all files in.
The default value is: `/install`

Default value: `lookup({name => 'wls_download_dir'})`

##### <a name="logoutput"></a>`logoutput`

Data type: `Variant[
    Boolean,
    Enum[
      'on_failure'
    ]
  ]`

log the outputs of Puppet exec or not.
When you specify `true` Puppet will log all output of `exec` types.
Valid values are:
- `true`
- `false`
- `on_failure`

Default value: `lookup({name => 'logoutput', default_value => 'on_failure'})`

### <a name="wls_installcopydomain"></a>`wls_install::copydomain`

wls_install::copydomain

It is used in conjunction with ora_install::packdomain to build WebLogic clusters. Here is an example on how you could use this:

```puppet
ora_install::copydomain{"Wls12c":
  version                => 1212,
  weblogic_home_dir      => "/opt/oracle/middleware12c/wlserver",
  middleware_home_dir    => "/opt/oracle/middleware12c",
  jdk_home_dir           => "/usr/java/jdk1.7.0_45",
  wls_domains_dir        => "/opt/oracle/domains",
  wls_apps_dir           => "/opt/oracle/applications",
  domain_name            => "Wls12c",
  os_user                => "oracle",
  os_group               => "dba",
  download_dir           => "/data/install",
  log_dir                => "/var/log/weblogic",
  logoutput             => true,
  use_ssh                => false,
  domain_pack_dir        => /mnt/fmw_share,
  adminserver_address    => "10.10.10.10",
  adminserver_port       => 7001,
  weblogic_user          => "weblogic",
  weblogic_password      => "weblogic1",
  setinternalappdeploymentondemandenable => false,
  setconfigbackupenabled                 => true,
  setarchiveconfigurationcount           => 10,
  setconfigurationaudittype              => 'logaudit',
}
```

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `wls_install::copydomain` defined type:

* [`version`](#version)
* [`middleware_home_dir`](#middleware_home_dir)
* [`weblogic_home_dir`](#weblogic_home_dir)
* [`jdk_home_dir`](#jdk_home_dir)
* [`wls_domains_dir`](#wls_domains_dir)
* [`wls_apps_dir`](#wls_apps_dir)
* [`use_ssh`](#use_ssh)
* [`domain_pack_dir`](#domain_pack_dir)
* [`domain_name`](#domain_name)
* [`adminserver_address`](#adminserver_address)
* [`adminserver_port`](#adminserver_port)
* [`administration_port`](#administration_port)
* [`administration_port_enabled`](#administration_port_enabled)
* [`adminserver_ssl_port`](#adminserver_ssl_port)
* [`user_config_file`](#user_config_file)
* [`user_key_file`](#user_key_file)
* [`weblogic_user`](#weblogic_user)
* [`weblogic_password`](#weblogic_password)
* [`os_user`](#os_user)
* [`os_group`](#os_group)
* [`download_dir`](#download_dir)
* [`log_dir`](#log_dir)
* [`server_start_mode`](#server_start_mode)
* [`wls_domains_file`](#wls_domains_file)
* [`copy_script`](#copy_script)
* [`puppet_os_user`](#puppet_os_user)
* [`jsse_enabled`](#jsse_enabled)
* [`custom_trust`](#custom_trust)
* [`trust_keystore_file`](#trust_keystore_file)
* [`trust_keystore_passphrase`](#trust_keystore_passphrase)
* [`extra_arguments`](#extra_arguments)
* [`logoutput`](#logoutput)

##### <a name="version"></a>`version`

Data type: `Wls_install::Versions`

The version that is installed in the used Oracle home.
Puppet uses this value to decide on version specific actions.

Default value: `lookup({name => 'wls_version', default_value => 1111})`

##### <a name="middleware_home_dir"></a>`middleware_home_dir`

Data type: `Stdlib::Absolutepath`

Middleware home directory.

Default value: `lookup({name => 'wls_middleware_home_dir'})`

##### <a name="weblogic_home_dir"></a>`weblogic_home_dir`

Data type: `Stdlib::Absolutepath`

Directory to use as WebLogic home.

Default value: `lookup({name => 'wls_weblogic_home_dir'})`

##### <a name="jdk_home_dir"></a>`jdk_home_dir`

Data type: `Stdlib::Absolutepath`

The homdirectory for the Java evelopment Kit.

Default value: `lookup({name => 'wls_jdk_home_dir'})`

##### <a name="wls_domains_dir"></a>`wls_domains_dir`

Data type: `Optional[Stdlib::Absolutepath]`

The root directory where all domain directories reside in.

Default value: `lookup({name => 'wls_domains_dir', default_value => undef})`

##### <a name="wls_apps_dir"></a>`wls_apps_dir`

Data type: `Optional[Stdlib::Absolutepath]`

The root directory where all aplication directories reside in.

Default value: `lookup({name => 'wls_apps_dir', default_value => undef})`

##### <a name="use_ssh"></a>`use_ssh`

Data type: `Boolean`

Boolean value specifying if you want to use ssh to copy the packed file.
You can only use this
when the ssh keys are already provided.

Default value: ``true``

##### <a name="domain_pack_dir"></a>`domain_pack_dir`

Data type: `Optional[Stdlib::Absolutepath]`

Directory where to put the packed directory.

Default value: ``undef``

##### <a name="domain_name"></a>`domain_name`

Data type: `String[1]`

The domain name.

Default value: `lookup({name => 'domain_name'})`

##### <a name="adminserver_address"></a>`adminserver_address`

Data type: `String[1]`

The address of the admin server.
May be a DNS name or a physical IP address.

Default value: `lookup({name => 'domain_adminserver_address'})`

##### <a name="adminserver_port"></a>`adminserver_port`

Data type: `Integer`

The IP port the admin server is listening on.

Default value: `lookup({name => 'domain_adminserver_port', default_value => 7001})`

##### <a name="administration_port"></a>`administration_port`

Data type: `Optional[Integer]`

The common secure administration port for this WebLogic Server domain.
(Requires you to enable the administration port.)

Default value: ``undef``

##### <a name="administration_port_enabled"></a>`administration_port_enabled`

Data type: `Boolean`

Specifies whether the domain-wide administration port should be enabled for this WebLogic Server domain.
Because the administration port uses SSL, enabling the administration port requires that SSL must be configured for all servers in the domain.
The domain-wide administration port enables you to start a WebLogic Server instance in STANDBY state. It also allows you to separate administration traffic from application traffic in your domain. Because all servers in the domain must enable or disable the administration port at once, you configure the default administration port settings at the domain level.
If you enable the administration port:
The administration port accepts only connections that specify administrator credentials.
Connections that specify administrator credentials can use only the administration port.
The command that starts managed servers must specify a secure protocol and the administration port: -Dweblogic.management.server=https://admin_server:administration_port

Default value: ``false``

##### <a name="adminserver_ssl_port"></a>`adminserver_ssl_port`

Data type: `Optional[Integer]`

SSL port to use for the Admin server.

Default value: ``undef``

##### <a name="user_config_file"></a>`user_config_file`

Data type: `Optional[String[1]]`

This parameter is not used (yet).

Default value: `lookup({name => 'domain_user_config_file', default_value => undef})`

##### <a name="user_key_file"></a>`user_key_file`

Data type: `Optional[String[1]]`

This parameter is not used (yet).

Default value: `lookup({name => 'domain_user_key_file', default_value => undef})`

##### <a name="weblogic_user"></a>`weblogic_user`

Data type: `String[1]`

The base WebLogic username to configure.

Default value: `lookup({name => 'wls_weblogic_user', default_value => 'weblogic'})`

##### <a name="weblogic_password"></a>`weblogic_password`

Data type: `Easy_type::Password`

The password of the base WebLogic user name.

Default value: `lookup({name => 'domain_wls_password', default_value => undef})`

##### <a name="os_user"></a>`os_user`

Data type: `String[1]`

The os user used to install and run WebLogic.

Default value: `lookup({name => 'wls_os_user'})`

##### <a name="os_group"></a>`os_group`

Data type: `String[1]`

The os group used to install and run WebLogic.

Default value: `lookup({name => 'wls_os_group'})`

##### <a name="download_dir"></a>`download_dir`

Data type: `Stdlib::Absolutepath`

The directory where the Puppet software puts all downloaded files.
Before Puppet can actually use remote files, they must be downloaded first. Puppet uses this directory to put all files in.
The default value is: `/install`

Default value: `lookup({name => 'wls_download_dir'})`

##### <a name="log_dir"></a>`log_dir`

Data type: `Optional[Stdlib::Absolutepath]`

Directory to use for logging.

Default value: `lookup({name => 'wls_log_dir', default_value => undef})`

##### <a name="server_start_mode"></a>`server_start_mode`

Data type: `Enum['dev','prod']`

Startmode to use.
This parameter id directly passed to the unpack and start of the domain.
Valid values are:
- dev
- prod

Default value: `'dev'`

##### <a name="wls_domains_file"></a>`wls_domains_file`

Data type: `Optional[String[1]]`

file containing the current domains available on the system.

Default value: ``undef``

##### <a name="copy_script"></a>`copy_script`

Data type: `Optional[String[1]]`

The user provided copy script to use for copying the packed domain.

Default value: ``undef``

##### <a name="puppet_os_user"></a>`puppet_os_user`

Data type: `String[1]`

The Puppet OS user to use.

Default value: `'root'`

##### <a name="jsse_enabled"></a>`jsse_enabled`

Data type: `Boolean`

Determine if you want to enable JSSE security.

Default value: `lookup({name => 'wls_jsse_enabled', default_value => false})`

##### <a name="custom_trust"></a>`custom_trust`

Data type: `Boolean`

Determine if you want to use a custom trust or not.

Default value: `lookup({name => 'wls_custom_trust', default_value => false})`

##### <a name="trust_keystore_file"></a>`trust_keystore_file`

Data type: `Optional[String[1]]`

File specificiation of the trust keystore.

Default value: `lookup({name => 'wls_trust_keystore_file', default_value => undef})`

##### <a name="trust_keystore_passphrase"></a>`trust_keystore_passphrase`

Data type: `Optional[Easy_type::Password]`

Passphrase to use for the trust keystore.

Default value: `lookup({name => 'wls_trust_keystore_passphrase', default_value => undef})`

##### <a name="extra_arguments"></a>`extra_arguments`

Data type: `Optional[String[1]]`

Extra java arguments to use.

Default value: `lookup({name => 'wls_install::copydomain::extra_arguments', default_value => undef})`

##### <a name="logoutput"></a>`logoutput`

Data type: `Variant[
    Boolean,
    Enum[
      'on_failure'
    ]
  ]`

log the outputs of Puppet exec or not.
When you specify `true` Puppet will log all output of `exec` types.
Valid values are:
- `true`
- `false`
- `on_failure`

Default value: `lookup({name => 'logoutput', default_value => 'on_failure'})`

### <a name="wls_installdomain"></a>`wls_install::domain`

wls_install::domain

It supports the following WebLogic versions:
- 1036
- 1111
- 1211
- 1212
- 1213

You can specify a domain template, thus specifying what kind of domain will be created. Using the template, you can create a Fusion Middleware enabled domain. The defined type supports the following templates:
- Standard
- Adf
- Osb
- osb_soa
- osb_soa_bpm
- soa
- soa_bpm

Here is an example on how you could use this:

```puppet
orawls::domain { 'wlsDomain12c':
  version                     => 1212
  weblogic_home_dir           => "/opt/oracle/middleware12c/wlserver",
  middleware_home_dir         => "/opt/oracle/middleware12c",
  jdk_home_dir                => "/usr/java/jdk1.7.0_45",
  domain_template             => "standard",
  domain_name                 => "Wls12c",
  development_mode            => false,
  adminserver_name            => "AdminServer",
  adminserver_address         => "localhost",
  adminserver_port            => 7001,
  nodemanager_secure_listener => true,
  nodemanager_port            => 5556,
  java_arguments              => { "ADM" => "...", "OSB" => "...", "SOA" => "...", "BAM" => "..."},
  weblogic_user               => "weblogic",
  weblogic_password           => "weblogic1",
  os_user                     => "oracle",
  os_group                    => "dba",
  log_dir                     => "/data/logs",
  download_dir                => "/data/install",
}

```

   Template you want to use for the domain.
   Valid values are:
   standard
   ohs_standalone
   adf_restricted
   osb
   osb_soa
   osb_soa_bpm
   soa
   soa_bpm
   bam
   adf
   oim
   oud
   wc
   wc_wcc_bpm

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `wls_install::domain` defined type:

* [`version`](#version)
* [`weblogic_home_dir`](#weblogic_home_dir)
* [`middleware_home_dir`](#middleware_home_dir)
* [`jdk_home_dir`](#jdk_home_dir)
* [`jdk_major_version`](#jdk_major_version)
* [`wls_domains_dir`](#wls_domains_dir)
* [`wls_apps_dir`](#wls_apps_dir)
* [`domain_template`](#domain_template)
* [`bam_enabled`](#bam_enabled)
* [`b2b_enabled`](#b2b_enabled)
* [`ess_enabled`](#ess_enabled)
* [`owsm_enabled`](#owsm_enabled)
* [`domain_name`](#domain_name)
* [`development_mode`](#development_mode)
* [`adminserver_name`](#adminserver_name)
* [`adminserver_machine_name`](#adminserver_machine_name)
* [`adminserver_address`](#adminserver_address)
* [`adminserver_port`](#adminserver_port)
* [`adminserver_ssl_port`](#adminserver_ssl_port)
* [`administration_port_enabled`](#administration_port_enabled)
* [`administration_port`](#administration_port)
* [`adminserver_listen_on_all_interfaces`](#adminserver_listen_on_all_interfaces)
* [`java_arguments`](#java_arguments)
* [`nodemanager_address`](#nodemanager_address)
* [`nodemanager_port`](#nodemanager_port)
* [`nodemanager_secure_listener`](#nodemanager_secure_listener)
* [`weblogic_user`](#weblogic_user)
* [`weblogic_password`](#weblogic_password)
* [`nodemanager_username`](#nodemanager_username)
* [`nodemanager_password`](#nodemanager_password)
* [`domain_password`](#domain_password)
* [`jsse_enabled`](#jsse_enabled)
* [`webtier_enabled`](#webtier_enabled)
* [`os_user`](#os_user)
* [`os_group`](#os_group)
* [`download_dir`](#download_dir)
* [`log_dir`](#log_dir)
* [`repository_database_url`](#repository_database_url)
* [`rcu_database_url`](#rcu_database_url)
* [`rcu_honor_omf`](#rcu_honor_omf)
* [`rcu_soa_profile`](#rcu_soa_profile)
* [`rcu_tablespace`](#rcu_tablespace)
* [`rcu_temp_tablespace`](#rcu_temp_tablespace)
* [`repository_prefix`](#repository_prefix)
* [`repository_password`](#repository_password)
* [`repository_sys_user`](#repository_sys_user)
* [`repository_sys_password`](#repository_sys_password)
* [`custom_trust`](#custom_trust)
* [`trust_keystore_file`](#trust_keystore_file)
* [`trust_keystore_passphrase`](#trust_keystore_passphrase)
* [`custom_identity`](#custom_identity)
* [`custom_identity_keystore_filename`](#custom_identity_keystore_filename)
* [`custom_identity_keystore_passphrase`](#custom_identity_keystore_passphrase)
* [`custom_identity_alias`](#custom_identity_alias)
* [`custom_identity_privatekey_passphrase`](#custom_identity_privatekey_passphrase)
* [`create_rcu`](#create_rcu)
* [`ohs_standalone_listen_address`](#ohs_standalone_listen_address)
* [`ohs_standalone_listen_port`](#ohs_standalone_listen_port)
* [`ohs_standalone_ssl_listen_port`](#ohs_standalone_ssl_listen_port)
* [`wls_domains_file`](#wls_domains_file)
* [`puppet_os_user`](#puppet_os_user)
* [`logoutput`](#logoutput)
* [`log_output`](#log_output)
* [`wls_apps_inside_domain`](#wls_apps_inside_domain)
* [`crossdomain_enabled`](#crossdomain_enabled)

##### <a name="version"></a>`version`

Data type: `Wls_install::Versions`

The version that is installed in the used Oracle home.
Puppet uses this value to decide on version specific actions.

Default value: `lookup({name => 'wls_version', default_value => 1111})`

##### <a name="weblogic_home_dir"></a>`weblogic_home_dir`

Data type: `Stdlib::Absolutepath`

Directory to use as WebLogic home.

Default value: `lookup({name => 'wls_weblogic_home_dir'})`

##### <a name="middleware_home_dir"></a>`middleware_home_dir`

Data type: `Stdlib::Absolutepath`

Middleware home directory.

Default value: `lookup({name => 'wls_middleware_home_dir'})`

##### <a name="jdk_home_dir"></a>`jdk_home_dir`

Data type: `Stdlib::Absolutepath`

The homdirectory for the Java evelopment Kit.

Default value: `lookup({name => 'wls_jdk_home_dir'})`

##### <a name="jdk_major_version"></a>`jdk_major_version`

Data type: `Variant[
    Integer[7,7],
    Integer[8,8]
  ]`

Major version of JDK to use.

Default value: `lookup({name => 'wls_jdk_major_version', default_value => 7})`

##### <a name="wls_domains_dir"></a>`wls_domains_dir`

Data type: `Optional[Stdlib::Absolutepath]`

The root directory where all domain directories reside in.

Default value: `lookup({name => 'wls_domains_dir', default_value => undef})`

##### <a name="wls_apps_dir"></a>`wls_apps_dir`

Data type: `Optional[Stdlib::Absolutepath]`

The root directory where all aplication directories reside in.

Default value: `lookup({name => 'wls_apps_dir', default_value => undef})`

##### <a name="domain_template"></a>`domain_template`

Data type: `Enum[
    'standard',
    'ohs_standalone',
    'adf_restricted',
    'osb',
    'osb_soa',
    'osb_soa_bpm',
    'soa',
    'soa_bpm',
    'bam',
    'adf',
    'oim',
    'oud',
    'wc',
    'wc_wcc_bpm',
    'forms',
    'bip'
  ]`



Default value: `lookup({name => 'domain_template', default_value => 'standard'})`

##### <a name="bam_enabled"></a>`bam_enabled`

Data type: `Boolean`

Boolean to determine in BAM is enabled.

Default value: ``true``

##### <a name="b2b_enabled"></a>`b2b_enabled`

Data type: `Boolean`

Boolean to determine if b2b is eanbled.

Default value: ``false``

##### <a name="ess_enabled"></a>`ess_enabled`

Data type: `Boolean`

Boolean to determine of ESS is enabled for the domain.

Default value: ``false``

##### <a name="owsm_enabled"></a>`owsm_enabled`

Data type: `Boolean`

Boolean to detrmine if owsm is enabled.

Default value: ``false``

##### <a name="domain_name"></a>`domain_name`

Data type: `String[1]`

The domain name.

Default value: `lookup({name => 'domain_name'})`

##### <a name="development_mode"></a>`development_mode`

Data type: `Boolean`

Boolean to determine if you want to create a development domain.

Default value: ``true``

##### <a name="adminserver_name"></a>`adminserver_name`

Data type: `String[1]`

The name of the Admin Server.

Default value: `lookup({name => 'domain_adminserver', default_value => 'AdminServer'})`

##### <a name="adminserver_machine_name"></a>`adminserver_machine_name`

Data type: `String[1]`

machine name you want to run the adminserver on.

Default value: `lookup({name => 'domain_adminserver_machine_name', default_value => 'LocalMachine'})`

##### <a name="adminserver_address"></a>`adminserver_address`

Data type: `String[1]`

The address of the admin server.
May be a DNS name or a physical IP address.

Default value: `lookup({name => 'domain_adminserver_address', default_value => undef})`

##### <a name="adminserver_port"></a>`adminserver_port`

Data type: `Integer`

The IP port the admin server is listening on.

Default value: `lookup({name => 'domain_adminserver_port', default_value => 7001})`

##### <a name="adminserver_ssl_port"></a>`adminserver_ssl_port`

Data type: `Optional[Integer]`

SSL port to use for the Admin server.

Default value: ``undef``

##### <a name="administration_port_enabled"></a>`administration_port_enabled`

Data type: `Boolean`

Specifies whether the domain-wide administration port should be enabled for this WebLogic Server domain.
Because the administration port uses SSL, enabling the administration port requires that SSL must be configured for all servers in the domain.
The domain-wide administration port enables you to start a WebLogic Server instance in STANDBY state. It also allows you to separate administration traffic from application traffic in your domain. Because all servers in the domain must enable or disable the administration port at once, you configure the default administration port settings at the domain level.
If you enable the administration port:
The administration port accepts only connections that specify administrator credentials.
Connections that specify administrator credentials can use only the administration port.
The command that starts managed servers must specify a secure protocol and the administration port: -Dweblogic.management.server=https://admin_server:administration_port

Default value: ``false``

##### <a name="administration_port"></a>`administration_port`

Data type: `Optional[Integer]`

The common secure administration port for this WebLogic Server domain.
(Requires you to enable the administration port.)

Default value: ``undef``

##### <a name="adminserver_listen_on_all_interfaces"></a>`adminserver_listen_on_all_interfaces`

Data type: `Boolean`

Boolean to determine if you want to let the adminserver listen on all interfaces.

Default value: ``false``

##### <a name="java_arguments"></a>`java_arguments`

Data type: `Hash`

Arguments to use when calling java.

Default value: `lookup({name => 'domain_java_arguments', default_value => {}})`

##### <a name="nodemanager_address"></a>`nodemanager_address`

Data type: `Optional[String[1]]`

Address the nodemanager is running on.
This may be a DNS name or a physical IP address.

Default value: ``undef``

##### <a name="nodemanager_port"></a>`nodemanager_port`

Data type: `Integer`

The IP port the nodemanager is listening on.

Default value: `lookup({name => 'domain_nodemanager_port', default_value => 5556})`

##### <a name="nodemanager_secure_listener"></a>`nodemanager_secure_listener`

Data type: `Boolean`

Use SSL for listening.

Default value: ``true``

##### <a name="weblogic_user"></a>`weblogic_user`

Data type: `String[1]`

The base WebLogic username to configure.

Default value: `lookup({name => 'wls_weblogic_user', default_value => 'weblogic'})`

##### <a name="weblogic_password"></a>`weblogic_password`

Data type: `Easy_type::Password`

The password of the base WebLogic user name.

Default value: `lookup({name => 'domain_wls_password'})`

##### <a name="nodemanager_username"></a>`nodemanager_username`

Data type: `Optional[String[1]]`

Username to use for nodemananer.

Default value: ``undef``

##### <a name="nodemanager_password"></a>`nodemanager_password`

Data type: `Optional[Easy_type::Password]`

Password to use for nodemanager.

Default value: ``undef``

##### <a name="domain_password"></a>`domain_password`

Data type: `Optional[Easy_type::Password]`

Password to use for the domain.

Default value: ``undef``

##### <a name="jsse_enabled"></a>`jsse_enabled`

Data type: `Boolean`

Determine if you want to enable JSSE security.

Default value: `lookup({name => 'wls_jsse_enabled', default_value => false})`

##### <a name="webtier_enabled"></a>`webtier_enabled`

Data type: `Boolean`

Boolean to determine if you want to enable the WebTier.

Default value: ``false``

##### <a name="os_user"></a>`os_user`

Data type: `String[1]`

The os user used to install and run WebLogic.

Default value: `lookup({name => 'wls_os_user'})`

##### <a name="os_group"></a>`os_group`

Data type: `String[1]`

The os group used to install and run WebLogic.

Default value: `lookup({name => 'wls_os_group'})`

##### <a name="download_dir"></a>`download_dir`

Data type: `Stdlib::Absolutepath`

The directory where the Puppet software puts all downloaded files.
Before Puppet can actually use remote files, they must be downloaded first. Puppet uses this directory to put all files in.
The default value is: `/install`

Default value: `lookup({name => 'wls_download_dir'})`

##### <a name="log_dir"></a>`log_dir`

Data type: `Optional[Stdlib::Absolutepath]`

Directory to use for logging.

Default value: `lookup({name => 'wls_log_dir', default_value => undef})`

##### <a name="repository_database_url"></a>`repository_database_url`

Data type: `Optional[String[1]]`

The jdbc URL of the RCU repository.

Default value: `lookup({name => 'repository_database_url', default_value => undef})`

##### <a name="rcu_database_url"></a>`rcu_database_url`

Data type: `Optional[String[1]]`

Database URL to create the RCU on.

Default value: ``undef``

##### <a name="rcu_honor_omf"></a>`rcu_honor_omf`

Data type: `Optional[Boolean]`

Boolean to determine if you want the RCU creation to honor OMF (Oracle Managed Files).

Default value: ``undef``

##### <a name="rcu_soa_profile"></a>`rcu_soa_profile`

Data type: `Optional[
    Enum[
      'SMALL',
      'MED',
      'LARGE'
    ]
  ]`

Profile to use for creating the RCU for SOA.

Default value: ``undef``

##### <a name="rcu_tablespace"></a>`rcu_tablespace`

Data type: `Optional[String[1]]`

The default tablespace to use for the RCU created accounts.

Default value: ``undef``

##### <a name="rcu_temp_tablespace"></a>`rcu_temp_tablespace`

Data type: `Optional[String[1]]`

The temporary tablespace to use for the RCU created accounts.

Default value: ``undef``

##### <a name="repository_prefix"></a>`repository_prefix`

Data type: `String[1]`

Extra prefix to use for the RCU.

Default value: `lookup({name => 'repository_prefix', default_value => 'DEV'})`

##### <a name="repository_password"></a>`repository_password`

Data type: `Optional[Easy_type::Password]`

The password to use for accessing the RCU repository.

Default value: `lookup({name => 'repository_password', default_value => undef})`

##### <a name="repository_sys_user"></a>`repository_sys_user`

Data type: `String[1]`

SYS username to use on the database where the RCU repository is created.
Default is 'SYS'
Default is 'SYS'

Default value: `'sys'`

##### <a name="repository_sys_password"></a>`repository_sys_password`

Data type: `Optional[Easy_type::Password]`

SYS password to use on the database where the RCU repository is created.

Default value: ``undef``

##### <a name="custom_trust"></a>`custom_trust`

Data type: `Boolean`

Determine if you want to use a custom trust or not.

Default value: `lookup({name => 'wls_custom_trust', default_value => false})`

##### <a name="trust_keystore_file"></a>`trust_keystore_file`

Data type: `Optional[String[1]]`

File specificiation of the trust keystore.

Default value: `lookup({name => 'wls_trust_keystore_file', default_value => undef})`

##### <a name="trust_keystore_passphrase"></a>`trust_keystore_passphrase`

Data type: `Optional[Easy_type::Password]`

Passphrase to use for the trust keystore.

Default value: `lookup({name => 'wls_trust_keystore_passphrase', default_value => undef})`

##### <a name="custom_identity"></a>`custom_identity`

Data type: `Boolean`

Determine if you want to use a custom identity store or not.

Default value: ``false``

##### <a name="custom_identity_keystore_filename"></a>`custom_identity_keystore_filename`

Data type: `Optional[String[1]]`

file name of the keystore identity file.

Default value: ``undef``

##### <a name="custom_identity_keystore_passphrase"></a>`custom_identity_keystore_passphrase`

Data type: `Optional[Easy_type::Password]`

Passphrase to use when opening the identity keystore.

Default value: ``undef``

##### <a name="custom_identity_alias"></a>`custom_identity_alias`

Data type: `Optional[String[1]]`

Alias for custom identity.

Default value: ``undef``

##### <a name="custom_identity_privatekey_passphrase"></a>`custom_identity_privatekey_passphrase`

Data type: `Optional[Easy_type::Password]`

Private passphrase to use when opening the identity keystore.

Default value: ``undef``

##### <a name="create_rcu"></a>`create_rcu`

Data type: `Boolean`

Determine if you want to create a RCU for the current domain.

Default value: `lookup({name => 'create_rcu', default_value => true})`

##### <a name="ohs_standalone_listen_address"></a>`ohs_standalone_listen_address`

Data type: `Optional[String[1]]`

Listen address for OHS standlone server.

Default value: ``undef``

##### <a name="ohs_standalone_listen_port"></a>`ohs_standalone_listen_port`

Data type: `Optional[Integer]`

Listen port for OHS standlone server.

Default value: ``undef``

##### <a name="ohs_standalone_ssl_listen_port"></a>`ohs_standalone_ssl_listen_port`

Data type: `Optional[Integer]`

SSL Listen port for OHS standlone server.

Default value: ``undef``

##### <a name="wls_domains_file"></a>`wls_domains_file`

Data type: `Optional[String[1]]`

file containing the current domains available on the system.

Default value: ``undef``

##### <a name="puppet_os_user"></a>`puppet_os_user`

Data type: `String[1]`

The Puppet OS user to use.

Default value: `'root'`

##### <a name="logoutput"></a>`logoutput`

Data type: `Variant[
    Boolean,
    Enum[
      'on_failure'
    ]
  ]`

log the outputs of Puppet exec or not.
When you specify `true` Puppet will log all output of `exec` types.
Valid values are:
- `true`
- `false`
- `on_failure`

Default value: `lookup({name => 'logoutput', default_value => 'on_failure'})`

##### <a name="log_output"></a>`log_output`

Data type: `Optional[
    Variant[
      Boolean,
      Enum[
        'on_failure'
      ]
    ]
  ]`



Default value: ``undef``

##### <a name="wls_apps_inside_domain"></a>`wls_apps_inside_domain`

Data type: `Optional[Boolean]`



Default value: ``false``

##### <a name="crossdomain_enabled"></a>`crossdomain_enabled`

Data type: `Optional[Boolean]`



Default value: ``true``

### <a name="wls_installfmw"></a>`wls_install::fmw`

wls_install::fmw

This defined type allows you to install the Fusion Middleware add-on software. It supports:- OSB- SOA Suite- WebTier (HTTP Server)- Oracle Identity Management- Web Center + ContentHere is an example on how you could use this:```puppetorawls::fmw{"osbPS6":  middleware_home_dir     => "/opt/oracle/middleware11gR1",  weblogic_home_dir       => "/opt/oracle/middleware11gR1/wlserver",  jdk_home_dir            => "/usr/java/jdk1.7.0_45",  oracle_base_home_dir    => "/opt/oracle",  fmw_product             => "osb",  # adf|soa|osb|oim|wc|wcc|web  fmw_file1               => "ofm_osb_generic_11.1.1.7.0_disk1_1of1.zip",  os_user                 => "oracle",  os_group                => "dba",  download_dir            => "/data/install",  source                  => "/vagrant",}```

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `wls_install::fmw` defined type:

* [`version`](#version)
* [`weblogic_home_dir`](#weblogic_home_dir)
* [`middleware_home_dir`](#middleware_home_dir)
* [`oracle_base_home_dir`](#oracle_base_home_dir)
* [`oracle_home_dir`](#oracle_home_dir)
* [`jdk_home_dir`](#jdk_home_dir)
* [`fmw_product`](#fmw_product)
* [`fmw_file1`](#fmw_file1)
* [`fmw_file2`](#fmw_file2)
* [`fmw_file3`](#fmw_file3)
* [`fmw_file4`](#fmw_file4)
* [`bpm`](#bpm)
* [`healthcare`](#healthcare)
* [`os_user`](#os_user)
* [`os_group`](#os_group)
* [`download_dir`](#download_dir)
* [`source`](#source)
* [`temp_directory`](#temp_directory)
* [`ohs_mode`](#ohs_mode)
* [`oracle_inventory_dir`](#oracle_inventory_dir)
* [`orainstpath_dir`](#orainstpath_dir)
* [`logoutput`](#logoutput)

##### <a name="version"></a>`version`

Data type: `Wls_install::Versions`

The version that is installed in the used Oracle home.
Puppet uses this value to decide on version specific actions.

Default value: `lookup({name => 'wls_version', default_value => 1111})`

##### <a name="weblogic_home_dir"></a>`weblogic_home_dir`

Data type: `Stdlib::Absolutepath`

Directory to use as WebLogic home.

Default value: `lookup({name => 'wls_weblogic_home_dir'})`

##### <a name="middleware_home_dir"></a>`middleware_home_dir`

Data type: `Stdlib::Absolutepath`

Middleware home directory.

Default value: `lookup({name => 'wls_middleware_home_dir'})`

##### <a name="oracle_base_home_dir"></a>`oracle_base_home_dir`

Data type: `Optional[Stdlib::Absolutepath]`

A directory to use as Oracle base directory.

Default value: `lookup({name => 'wls_oracle_base_home_dir'})`

##### <a name="oracle_home_dir"></a>`oracle_home_dir`

Data type: `Optional[Stdlib::Absolutepath]`

A directory to be used as Oracle home directory for this software.

Default value: ``undef``

##### <a name="jdk_home_dir"></a>`jdk_home_dir`

Data type: `Stdlib::Absolutepath`

The homdirectory for the Java evelopment Kit.

Default value: `lookup({name => 'wls_jdk_home_dir'})`

##### <a name="fmw_product"></a>`fmw_product`

Data type: `Wls_install::Fmw_products`

Type of Fusion Middleware Product you want to install.
Valid values are:
- adf
- soa
- soaqs
- osb
- wcc
- wc
- oim
- oam
- web
- webgate
- oud
- mft
- b2b
- forms

Default value: ``undef``

##### <a name="fmw_file1"></a>`fmw_file1`

Data type: `Optional[String[1]]`

First file of FMW distribution.

Default value: ``undef``

##### <a name="fmw_file2"></a>`fmw_file2`

Data type: `Optional[String[1]]`

Second file of FMW distribution.

Default value: ``undef``

##### <a name="fmw_file3"></a>`fmw_file3`

Data type: `Optional[String[1]]`

Third file of FMW distribution.

Default value: ``undef``

##### <a name="fmw_file4"></a>`fmw_file4`

Data type: `Optional[String[1]]`

Fourth file of FMW distribution.

Default value: ``undef``

##### <a name="bpm"></a>`bpm`

Data type: `Boolean`

Boolean to determine if you want to enable BPM.

Default value: ``false``

##### <a name="healthcare"></a>`healthcare`

Data type: `Boolean`

Boolean to determine if you want to enable healthcare.

Default value: ``false``

##### <a name="os_user"></a>`os_user`

Data type: `String[1]`

The os user used to install and run WebLogic.

Default value: `lookup({name => 'wls_os_user'})`

##### <a name="os_group"></a>`os_group`

Data type: `String[1]`

The os group used to install and run WebLogic.

Default value: `lookup({name => 'wls_os_group'})`

##### <a name="download_dir"></a>`download_dir`

Data type: `Stdlib::Absolutepath`

The directory where the Puppet software puts all downloaded files.
Before Puppet can actually use remote files, they must be downloaded first. Puppet uses this directory to put all files in.
The default value is: `/install`

Default value: `lookup({name => 'wls_download_dir'})`

##### <a name="source"></a>`source`

Data type: `String[1]`

Source for the operation.

Default value: `lookup({name => 'wls_source', default_value => undef})`

##### <a name="temp_directory"></a>`temp_directory`

Data type: `Stdlib::Absolutepath`

Directory to use for temporary files.

Default value: `lookup({name => 'wls_temp_dir', default_value => '/tmp'})`

##### <a name="ohs_mode"></a>`ohs_mode`

Data type: `Enum[
    'colocated',
    'collocated',
    'standalone'
  ]`

Type of OHS mode.
Valid values are:
- colocated
- collocated
- standalone

Default value: `lookup({name => 'ohs_mode', default_value => 'collocated'})`

##### <a name="oracle_inventory_dir"></a>`oracle_inventory_dir`

Data type: `Optional[Stdlib::Absolutepath]`

The directory that contains the oracle inventory.
The default value is: `/oracle_base/oraInventory`

Default value: ``undef``

##### <a name="orainstpath_dir"></a>`orainstpath_dir`

Data type: `Optional[Stdlib::Absolutepath]`

Path where to find the oraint.
loc file.

Default value: `lookup({name => 'orainstpath_dir', default_value => undef})`

##### <a name="logoutput"></a>`logoutput`

Data type: `Variant[
    Boolean,
    Enum[
      'on_failure'
    ]
  ]`

log the outputs of Puppet exec or not.
When you specify `true` Puppet will log all output of `exec` types.
Valid values are:
- `true`
- `false`
- `on_failure`

Default value: `lookup({name => 'logoutput', default_value => 'on_failure'})`

### <a name="wls_installfmwlogdir"></a>`wls_install::fmwlogdir`

wls_install::fmwlogdir

Here is an example on how you could use this:

```puppet
wls_install::fmwlogdir { 'AdminServer':
  middleware_home_dir    => "/opt/oracle/middleware11gR1",
  weblogic_user          => "weblogic",
  weblogic_password      => "weblogic1",
  os_user                => "oracle",
  os_group               => "dba",
  download_dir           => "/data/install"
  log_dir                => "/var/log/weblogic"
  adminserver_address    => "localhost",
  adminserver_port       => 7001,
  server                 => "AdminServer",
}
```

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `wls_install::fmwlogdir` defined type:

* [`middleware_home_dir`](#middleware_home_dir)
* [`adminserver_address`](#adminserver_address)
* [`adminserver_port`](#adminserver_port)
* [`weblogic_user`](#weblogic_user)
* [`weblogic_password`](#weblogic_password)
* [`user_config_file`](#user_config_file)
* [`user_key_file`](#user_key_file)
* [`userConfigFile`](#userConfigFile)
* [`userKeyFile`](#userKeyFile)
* [`os_user`](#os_user)
* [`os_group`](#os_group)
* [`download_dir`](#download_dir)
* [`server`](#server)
* [`log_dir`](#log_dir)
* [`logoutput`](#logoutput)

##### <a name="middleware_home_dir"></a>`middleware_home_dir`

Data type: `Stdlib::Absolutepath`

Middleware home directory.

Default value: `lookup({name => 'wls_middleware_home_dir'})`

##### <a name="adminserver_address"></a>`adminserver_address`

Data type: `String[1]`

The address of the admin server.
May be a DNS name or a physical IP address.

Default value: `lookup({name => 'domain_adminserver_address', default_value => 'localhost'})`

##### <a name="adminserver_port"></a>`adminserver_port`

Data type: `Integer`

The IP port the admin server is listening on.

Default value: `lookup({name => 'domain_adminserver_port', default_value => 7001})`

##### <a name="weblogic_user"></a>`weblogic_user`

Data type: `String[1]`

The base WebLogic username to configure.

Default value: `lookup({name => 'wls_weblogic_user', default_value => 'weblogic'})`

##### <a name="weblogic_password"></a>`weblogic_password`

Data type: `Optional[Easy_type::Password]`

The password of the base WebLogic user name.

Default value: `lookup({name => 'domain_wls_password', default_value => undef})`

##### <a name="user_config_file"></a>`user_config_file`

Data type: `Optional[String[1]]`



Default value: `lookup({name => 'domain_user_config_file', default_value => undef})`

##### <a name="user_key_file"></a>`user_key_file`

Data type: `Optional[String[1]]`



Default value: `lookup({name => 'domain_user_key_file', default_value => undef})`

##### <a name="userConfigFile"></a>`userConfigFile`



##### <a name="userKeyFile"></a>`userKeyFile`



##### <a name="os_user"></a>`os_user`

Data type: `String[1]`

The os user used to install and run WebLogic.

Default value: `lookup({name => 'wls_os_user'})`

##### <a name="os_group"></a>`os_group`

Data type: `String[1]`

The os group used to install and run WebLogic.

Default value: `lookup({name => 'wls_os_group'})`

##### <a name="download_dir"></a>`download_dir`

Data type: `Stdlib::Absolutepath`

The directory where the Puppet software puts all downloaded files.
Before Puppet can actually use remote files, they must be downloaded first. Puppet uses this directory to put all files in.
The default value is: `/install`

Default value: `lookup({name => 'wls_download_dir'})`

##### <a name="server"></a>`server`

Data type: `String[1]`



Default value: `'AdminServer'`

##### <a name="log_dir"></a>`log_dir`

Data type: `Stdlib::Absolutepath`

Directory to use for logging.

Default value: `lookup({name => 'wls_log_dir', default_value => undef})`

##### <a name="logoutput"></a>`logoutput`

Data type: `Variant[
    Boolean,
    Enum[
      'on_failure'
    ]
  ]`

log the outputs of Puppet exec or not.
When you specify `true` Puppet will log all output of `exec` types.
Valid values are:
- `true`
- `false`
- `on_failure`

Default value: `lookup({name => 'logoutput', default_value => 'on_failure'})`

### <a name="wls_installincreased_memory_bsu"></a>`wls_install::increased_memory_bsu`

wls_install::increased_memory_bsu

Patches the BSU utility to increase the amount of memory available for patches.

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `wls_install::increased_memory_bsu` defined type:

* [`middleware_home_dir`](#middleware_home_dir)
* [`jdk_home_dir`](#jdk_home_dir)
* [`os_user`](#os_user)
* [`os_group`](#os_group)
* [`download_dir`](#download_dir)
* [`logoutput`](#logoutput)

##### <a name="middleware_home_dir"></a>`middleware_home_dir`

Data type: `Stdlib::Absolutepath`

Middleware home directory.

Default value: `lookup({name => 'wls_middleware_home_dir'})`

##### <a name="jdk_home_dir"></a>`jdk_home_dir`

Data type: `Stdlib::Absolutepath`

The homdirectory for the Java evelopment Kit.

Default value: `lookup({name => 'wls_jdk_home_dir'})`

##### <a name="os_user"></a>`os_user`

Data type: `String[1]`

The os user used to install and run WebLogic.

Default value: `lookup({name => 'wls_os_user'})`

##### <a name="os_group"></a>`os_group`

Data type: `Srting[1]`

The os group used to install and run WebLogic.

Default value: `lookup({name => 'wls_os_group'})`

##### <a name="download_dir"></a>`download_dir`

Data type: `Stdlib::Absolutepath`

The directory where the Puppet software puts all downloaded files.
Before Puppet can actually use remote files, they must be downloaded first. Puppet uses this directory to put all files in.
The default value is: `/install`

Default value: `lookup({name => 'wls_download_dir'})`

##### <a name="logoutput"></a>`logoutput`

Data type: `Variant[
    Boolean,
    Enum[
      'on_failure'
    ]
  ]`

log the outputs of Puppet exec or not.
When you specify `true` Puppet will log all output of `exec` types.
Valid values are:
- `true`
- `false`
- `on_failure`

Default value: `lookup({name => 'logoutput', default_value => 'on_failure'})`

### <a name="wls_installmanaged_server"></a>`wls_install::managed_server`

wls_install::managed_server

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `wls_install::managed_server` defined type:

* [`domain`](#domain)
* [`machine`](#machine)
* [`listenaddress`](#listenaddress)
* [`listenport`](#listenport)
* [`ssllistenport`](#ssllistenport)
* [`server_arguments`](#server_arguments)
* [`wls_log_dir`](#wls_log_dir)

##### <a name="domain"></a>`domain`

Data type: `String[1]`

Domain name.

##### <a name="machine"></a>`machine`

Data type: `String[1]`

Name of the weblogic machine to use.

##### <a name="listenaddress"></a>`listenaddress`

Data type: `String[1]`

The address to use for listening.
Mat be a physical IP address or a DNS name.

##### <a name="listenport"></a>`listenport`

Data type: `Integer`

IP port to listen on.

##### <a name="ssllistenport"></a>`ssllistenport`

Data type: `Integer`

SSL listen port to use.

##### <a name="server_arguments"></a>`server_arguments`

Data type: `Array`

Java arguments to use when runing the managed server.

##### <a name="wls_log_dir"></a>`wls_log_dir`

Data type: `Optional[Stdlib::Absolutepath]`

The directory where all log files are places.

Default value: `lookup({name => 'wls_log_dir', default_value => undef})`

### <a name="wls_installnodemanager"></a>`wls_install::nodemanager`

wls_install::nodemanager

Here is an example on how you could use this:

```puppet
ora_install::nodemanager{'nodemanager12c':
  version                     => 1212, # 1036|1111|1211|1212
  weblogic_home_dir           => "/opt/oracle/middleware12c/wlserver",
  jdk_home_dir                => "/usr/java/jdk1.7.0_45",
  nodemanager_port            => 5556,
  nodemanager_secure_listener => true,
  domain_name                 => "Wls12c",
  os_user                     => "oracle",
  os_group                    => "dba",
  log_dir                     => "/data/logs",
  download_dir                => "/data/install",
  logoutput                  => true,
  sleep                       => 20,
  properties                  => {},
}
```

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `wls_install::nodemanager` defined type:

* [`version`](#version)
* [`middleware_home_dir`](#middleware_home_dir)
* [`weblogic_home_dir`](#weblogic_home_dir)
* [`nodemanager_port`](#nodemanager_port)
* [`nodemanager_address`](#nodemanager_address)
* [`nodemanager_secure_listener`](#nodemanager_secure_listener)
* [`jsse_enabled`](#jsse_enabled)
* [`custom_trust`](#custom_trust)
* [`trust_keystore_file`](#trust_keystore_file)
* [`trust_keystore_passphrase`](#trust_keystore_passphrase)
* [`custom_identity`](#custom_identity)
* [`custom_identity_keystore_filename`](#custom_identity_keystore_filename)
* [`custom_identity_keystore_passphrase`](#custom_identity_keystore_passphrase)
* [`custom_identity_alias`](#custom_identity_alias)
* [`custom_identity_privatekey_passphrase`](#custom_identity_privatekey_passphrase)
* [`extra_arguments`](#extra_arguments)
* [`wls_domains_dir`](#wls_domains_dir)
* [`domain_name`](#domain_name)
* [`jdk_home_dir`](#jdk_home_dir)
* [`os_user`](#os_user)
* [`os_group`](#os_group)
* [`download_dir`](#download_dir)
* [`log_dir`](#log_dir)
* [`log_file`](#log_file)
* [`sleep`](#sleep)
* [`properties`](#properties)
* [`ohs_standalone`](#ohs_standalone)
* [`puppet_os_user`](#puppet_os_user)
* [`logoutput`](#logoutput)

##### <a name="version"></a>`version`

Data type: `Wls_install::Versions`

The version that is installed in the used Oracle home.
Puppet uses this value to decide on version specific actions.

Default value: `lookup({name => 'wls_version', default_value => 1111})`

##### <a name="middleware_home_dir"></a>`middleware_home_dir`

Data type: `Stdlib::Absolutepath`

Middleware home directory.

Default value: `lookup({name => 'wls_middleware_home_dir'})`

##### <a name="weblogic_home_dir"></a>`weblogic_home_dir`

Data type: `Stdlib::Absolutepath`

Directory to use as WebLogic home.

Default value: `lookup({name => 'wls_weblogic_home_dir'})`

##### <a name="nodemanager_port"></a>`nodemanager_port`

Data type: `Integer`

The IP port the nodemanager is listening on.

Default value: `lookup({name => 'domain_nodemanager_port', default_value => 5556})`

##### <a name="nodemanager_address"></a>`nodemanager_address`

Data type: `String[1]`

Address the nodemanager is running on.
This may be a DNS name or a physical IP address.

Default value: ``undef``

##### <a name="nodemanager_secure_listener"></a>`nodemanager_secure_listener`

Data type: `Boolean`

Use SSL for listening.

Default value: ``true``

##### <a name="jsse_enabled"></a>`jsse_enabled`

Data type: `Boolean`

Determine if you want to enable JSSE security.

Default value: `lookup({name => 'wls_jsse_enabled', default_value => false})`

##### <a name="custom_trust"></a>`custom_trust`

Data type: `Boolean`

Determine if you want to use a custom trust or not.

Default value: `lookup({name => 'wls_custom_trust', default_value => false})`

##### <a name="trust_keystore_file"></a>`trust_keystore_file`

Data type: `Optional[String[1]]`

File specificiation of the trust keystore.

Default value: `lookup({name => 'wls_trust_keystore_file', default_value => undef})`

##### <a name="trust_keystore_passphrase"></a>`trust_keystore_passphrase`

Data type: `Optional[Easy_type::Password]`

Passphrase to use for the trust keystore.

Default value: `lookup({name => 'wls_trust_keystore_passphrase', default_value => undef})`

##### <a name="custom_identity"></a>`custom_identity`

Data type: `Boolean`

Determine if you want to use a custom identity store or not.

Default value: ``false``

##### <a name="custom_identity_keystore_filename"></a>`custom_identity_keystore_filename`

Data type: `Optional[String[1]]`

file name of the keystore identity file.

Default value: ``undef``

##### <a name="custom_identity_keystore_passphrase"></a>`custom_identity_keystore_passphrase`

Data type: `Optional[Easy_type::Password]`

Passphrase to use when opening the identity keystore.

Default value: ``undef``

##### <a name="custom_identity_alias"></a>`custom_identity_alias`

Data type: `Optional[String[1]]`

Alias for custom identity.

Default value: ``undef``

##### <a name="custom_identity_privatekey_passphrase"></a>`custom_identity_privatekey_passphrase`

Data type: `Optional[Easy_type::Password]`

Private passphrase to use when opening the identity keystore.

Default value: ``undef``

##### <a name="extra_arguments"></a>`extra_arguments`

Data type: `String`

Extra java arguments to use.

Default value: `''`

##### <a name="wls_domains_dir"></a>`wls_domains_dir`

Data type: `Optional[
    Stdlib::Absolutepath
  ]`

The root directory where all domain directories reside in.

Default value: `lookup({name => 'wls_domains_dir', default_value => undef})`

##### <a name="domain_name"></a>`domain_name`

Data type: `Optional[
    String[1]]`

The domain name.

Default value: `lookup({name => 'domain_name', default_value => undef})`

##### <a name="jdk_home_dir"></a>`jdk_home_dir`

Data type: `Stdlib::Absolutepath`

The homdirectory for the Java evelopment Kit.

Default value: `lookup({name => 'wls_jdk_home_dir'})`

##### <a name="os_user"></a>`os_user`

Data type: `String[1]`

The os user used to install and run WebLogic.

Default value: `lookup({name => 'wls_os_user'})`

##### <a name="os_group"></a>`os_group`

Data type: `String[1]`

The os group used to install and run WebLogic.

Default value: `lookup({name => 'wls_os_group'})`

##### <a name="download_dir"></a>`download_dir`

Data type: `Stdlib::Absolutepath`

The directory where the Puppet software puts all downloaded files.
Before Puppet can actually use remote files, they must be downloaded first. Puppet uses this directory to put all files in.
The default value is: `/install`

Default value: `lookup({name => 'wls_download_dir'})`

##### <a name="log_dir"></a>`log_dir`

Data type: `Optional[
    Stdlib::Absolutepath
  ]`

Directory to use for logging.

Default value: `lookup({name => 'wls_log_dir', default_value => undef})`

##### <a name="log_file"></a>`log_file`

Data type: `String[1]`

Log file to use.

Default value: `'nodemanager.log'`

##### <a name="sleep"></a>`sleep`

Data type: `Integer`

Maximum time to wait to check if nodemanger is running correctly.
If time expires, the type will fail.

Default value: `lookup({name => 'wls_nodemanager_sleep', default_value => 20})`

##### <a name="properties"></a>`properties`

Data type: `Hash`

Properties to use.

Default value: `{}`

##### <a name="ohs_standalone"></a>`ohs_standalone`

Data type: `Boolean`

Boolean to determine if you want to use OHS standalone mode.

Default value: ``false``

##### <a name="puppet_os_user"></a>`puppet_os_user`

Data type: `String[1]`

The Puppet OS user to use.

Default value: `lookup({name => 'puppet_os_user', default_value => 'root'})`

##### <a name="logoutput"></a>`logoutput`

Data type: `Variant[
    Boolean,
    Enum[
      'on_failure'
    ]
  ]`

log the outputs of Puppet exec or not.
When you specify `true` Puppet will log all output of `exec` types.
Valid values are:
- `true`
- `false`
- `on_failure`

Default value: `lookup({name => 'logoutput', default_value => 'on_failure'})`

### <a name="wls_installopatchupgrade"></a>`wls_install::opatchupgrade`

wls_install::opatchupgrade

It will extract the ziop file you specify as `source` and run the Opatch installer to ensure the correct version of opatch is installed.

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `wls_install::opatchupgrade` defined type:

* [`opatch_version`](#opatch_version)
* [`oracle_home_dir`](#oracle_home_dir)
* [`patch_file`](#patch_file)
* [`source`](#source)
* [`os_user`](#os_user)
* [`os_group`](#os_group)
* [`jdk_home_dir`](#jdk_home_dir)
* [`download_dir`](#download_dir)
* [`temp_directory`](#temp_directory)
* [`logoutput`](#logoutput)

##### <a name="opatch_version"></a>`opatch_version`

Data type: `String[1]`

The version of opatch you want ensure is installed on your system.
When there is a difference between the currently detected Opatch version and the version you specify here, Puppet will install the Opatch version that is in your zip file specified by the `source` parameter.
If however this zip file contains a different version, this class will not idempotent.

##### <a name="oracle_home_dir"></a>`oracle_home_dir`

Data type: `Stdlib::Absolutepath`

A directory to be used as Oracle home directory for this software.

##### <a name="patch_file"></a>`patch_file`

Data type: `String[1]`

The zip file containing the required Opatch version.

##### <a name="source"></a>`source`

Data type: `String[1]`

Source for the operation.

Default value: `lookup({name => 'wls_source', default_value => undef})`

##### <a name="os_user"></a>`os_user`

Data type: `String[1]`

The os user used to install and run WebLogic.

Default value: `lookup({name => 'wls_os_user', default_value => undef})`

##### <a name="os_group"></a>`os_group`

Data type: `String[1]`

The os group used to install and run WebLogic.

Default value: `lookup({name => 'wls_os_group', default_value => undef})`

##### <a name="jdk_home_dir"></a>`jdk_home_dir`

Data type: `Stdlib::Absolutepath`

The homdirectory for the Java evelopment Kit.

Default value: `lookup({name => 'wls_jdk_home_dir'})`

##### <a name="download_dir"></a>`download_dir`

Data type: `Stdlib::Absolutepath`

The directory where the Puppet software puts all downloaded files.
Before Puppet can actually use remote files, they must be downloaded first. Puppet uses this directory to put all files in.
The default value is: `/install`

Default value: `lookup({name => 'wls_download_dir', default_value => undef})`

##### <a name="temp_directory"></a>`temp_directory`

Data type: `Stdlib::Absolutepath`

Directory to use for temporary files.

Default value: `'/tmp'`

##### <a name="logoutput"></a>`logoutput`

Data type: `Variant[
    Boolean,
    Enum[
      'on_failure'
    ]
  ]`

log the outputs of Puppet exec or not.
When you specify `true` Puppet will log all output of `exec` types.
Valid values are:
- `true`
- `false`
- `on_failure`

Default value: `lookup({name => 'logoutput', default_value => 'on_failure'})`

### <a name="wls_installordsconfig"></a>`wls_install::ords::config`

wls_install::ords::config

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `wls_install::ords::config` defined type:

* [`db_hostname`](#db_hostname)
* [`db_port`](#db_port)
* [`db_servicename`](#db_servicename)
* [`db_sid`](#db_sid)
* [`db_username`](#db_username)
* [`migrate_apex_rest`](#migrate_apex_rest)
* [`plsql_gateway_add`](#plsql_gateway_add)
* [`rest_services_apex_add`](#rest_services_apex_add)
* [`rest_services_ords_add`](#rest_services_ords_add)
* [`schema_tablespace_default`](#schema_tablespace_default)
* [`schema_tablespace_temp`](#schema_tablespace_temp)
* [`standalone_http_port`](#standalone_http_port)
* [`standalone_static_images`](#standalone_static_images)
* [`user_public_password`](#user_public_password)
* [`user_tablespace_default`](#user_tablespace_default)
* [`user_tablespace_temp`](#user_tablespace_temp)
* [`sys_user`](#sys_user)
* [`sys_password`](#sys_password)
* [`logoutput`](#logoutput)

##### <a name="db_hostname"></a>`db_hostname`

Data type: `String[1]`

The hostname of the machine where the database is running.

##### <a name="db_port"></a>`db_port`

Data type: `Integer`

The port of the machine where the database is running.

##### <a name="db_servicename"></a>`db_servicename`

Data type: `String[1]`

The name of the service where database is running.

##### <a name="db_sid"></a>`db_sid`

Data type: `String[1]`

The service id of the machine where the database is running.

##### <a name="db_username"></a>`db_username`

Data type: `String[1]`

The name  of the database user.

##### <a name="migrate_apex_rest"></a>`migrate_apex_rest`

Data type: `Boolean`

Flag defining if APEX REST api should be migrated.

##### <a name="plsql_gateway_add"></a>`plsql_gateway_add`

Data type: `Boolean`

Flag defining if plsql gateway should be added to weblogic.

##### <a name="rest_services_apex_add"></a>`rest_services_apex_add`

Data type: `Boolean`

Flag defining if apex rest services should be added to weblogic.

##### <a name="rest_services_ords_add"></a>`rest_services_ords_add`

Data type: `Boolean`

Flag defining if ords rest services should be added to weblogic.

##### <a name="schema_tablespace_default"></a>`schema_tablespace_default`

Data type: `String[1]`

The default tablespace schema.

##### <a name="schema_tablespace_temp"></a>`schema_tablespace_temp`

Data type: `String[1]`

The temporary tablespace schema.

##### <a name="standalone_http_port"></a>`standalone_http_port`

Data type: `Integer`

The standalone http port.

##### <a name="standalone_static_images"></a>`standalone_static_images`

Data type: `Boolean`

The standalone static images.

##### <a name="user_public_password"></a>`user_public_password`

Data type: `String[1]`

The public password of the user.

##### <a name="user_tablespace_default"></a>`user_tablespace_default`

Data type: `String[1]`

The default tablespace of the user.

##### <a name="user_tablespace_temp"></a>`user_tablespace_temp`

Data type: `String[1]`

The temporary tablespace of the user.

##### <a name="sys_user"></a>`sys_user`

Data type: `String[1]`

The system user.

##### <a name="sys_password"></a>`sys_password`

Data type: `String[1]`

The system user password.

##### <a name="logoutput"></a>`logoutput`

Data type: `Variant[Enum['on_failure'], Boolean]`

log the outputs of Puppet exec or not.
When you specify `true` Puppet will log all output of `exec` types.
Valid values are:
- `true`
- `false`
- `on_failure`

Default value: `'on_failure'`

### <a name="wls_installordssoftware_version"></a>`wls_install::ords::software_version`

wls_install::ords::software_version

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `wls_install::ords::software_version` defined type:

* [`file`](#file)
* [`ords_home`](#ords_home)
* [`source`](#source)
* [`temp_dir`](#temp_dir)
* [`logoutput`](#logoutput)

##### <a name="file"></a>`file`

Data type: `String[1]`

The name of the ords install file.

##### <a name="ords_home"></a>`ords_home`

Data type: `Stdlib::Absolutepath`

The ords home path.

##### <a name="source"></a>`source`

Data type: `String[1]`

Source for the operation.

##### <a name="temp_dir"></a>`temp_dir`

Data type: `Stdlib::Absolutepath`

The temporary directory path.

Default value: `'/tmp'`

##### <a name="logoutput"></a>`logoutput`

Data type: `Variant[Enum['on_failure'], Boolean]`

log the outputs of Puppet exec or not.
When you specify `true` Puppet will log all output of `exec` types.
Valid values are:
- `true`
- `false`
- `on_failure`

Default value: `'on_failure'`

### <a name="wls_installpackdomain"></a>`wls_install::packdomain`

wls_install::packdomain

This defined type allows you pack the definition of your domain into a file. Using ora_install::copydomain, you can copy it to an other node and create a WebLogic cluster.Here is an example on how you could use this:```puppetora_install::packdomain{"Wls12c":  weblogic_home_dir      => "/opt/oracle/middleware12c/wlserver",  middleware_home_dir    => "/opt/oracle/middleware12c",  jdk_home_dir           => "/usr/java/jdk1.7.0_45",  wls_domains_dir        => "/opt/oracle/domains",  domain_name            => "Wls12c",  os_user                => "oracle",  os_group               => "dba",  download_dir           => "/data/install",}```

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `wls_install::packdomain` defined type:

* [`version`](#version)
* [`weblogic_home_dir`](#weblogic_home_dir)
* [`middleware_home_dir`](#middleware_home_dir)
* [`jdk_home_dir`](#jdk_home_dir)
* [`wls_domains_dir`](#wls_domains_dir)
* [`domain_name`](#domain_name)
* [`os_user`](#os_user)
* [`os_group`](#os_group)
* [`download_dir`](#download_dir)
* [`logoutput`](#logoutput)

##### <a name="version"></a>`version`

Data type: `Wls_install::Versions`

The version that is installed in the used Oracle home.
Puppet uses this value to decide on version specific actions.

Default value: `lookup({name => 'wls_version', default_value => 1111})`

##### <a name="weblogic_home_dir"></a>`weblogic_home_dir`

Data type: `Stdlib::Absolutepath`

Directory to use as WebLogic home.

Default value: `lookup({name => 'wls_weblogic_home_dir'})`

##### <a name="middleware_home_dir"></a>`middleware_home_dir`

Data type: `Stdlib::Absolutepath`

Middleware home directory.

Default value: `lookup({name => 'wls_middleware_home_dir'})`

##### <a name="jdk_home_dir"></a>`jdk_home_dir`

Data type: `Stdlib::Absolutepath`

The homdirectory for the Java evelopment Kit.

Default value: `lookup({name => 'wls_jdk_home_dir'})`

##### <a name="wls_domains_dir"></a>`wls_domains_dir`

Data type: `Stdlib::Absolutepath`

The root directory where all domain directories reside in.

Default value: `lookup({name => 'wls_domains_dir', default_value => undef})`

##### <a name="domain_name"></a>`domain_name`

Data type: `String[1]`

The domain name.

Default value: `lookup({name => 'domain_name'})`

##### <a name="os_user"></a>`os_user`

Data type: `String[1]`

The os user used to install and run WebLogic.

Default value: `lookup({name => 'wls_os_user'})`

##### <a name="os_group"></a>`os_group`

Data type: `String[1]`

The os group used to install and run WebLogic.

Default value: `lookup({name => 'wls_os_group'})`

##### <a name="download_dir"></a>`download_dir`

Data type: `Stdlib::Absolutepath`

The directory where the Puppet software puts all downloaded files.
Before Puppet can actually use remote files, they must be downloaded first. Puppet uses this directory to put all files in.
The default value is: `/install`

Default value: `lookup({name => 'wls_download_dir'})`

##### <a name="logoutput"></a>`logoutput`

Data type: `Variant[
    Boolean,
    Enum[
      'on_failure'
    ]
  ]`

log the outputs of Puppet exec or not.
When you specify `true` Puppet will log all output of `exec` types.
Valid values are:
- `true`
- `false`
- `on_failure`

Default value: `lookup({name => 'logoutput', default_value => 'on_failure'})`

### <a name="wls_installsoftware_version"></a>`wls_install::software_version`

wls_install::software_version

You can use this to install multiple versions on your system.

Here is an example on how you could use this:

```
ora_install::software_version{'1221':
  version              => 1221,                       # 1036|1211|1212|1213|1221
  filename             => 'fmw_12.2.1.0.0_wls.jar',   #
  jdk_home_dir         => '/usr/java/jdk1.8.0_45',
  oracle_base_home_dir => "/opt/oracle",
  middleware_home_dir  => "/opt/oracle/middleware12c",
  weblogic_home_dir    => "/opt/oracle/middleware12c/wlserver",
  os_user              => "oracle",
  os_group             => "dba",
  download_dir         => "/data/install",
  source               => "/vagrant",                 # puppet:///modules/orawls/ | /mnt |
  logoutput           => true,
}
```

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `wls_install::software_version` defined type:

* [`version`](#version)
* [`filename`](#filename)
* [`oracle_base_home_dir`](#oracle_base_home_dir)
* [`middleware_home_dir`](#middleware_home_dir)
* [`weblogic_home_dir`](#weblogic_home_dir)
* [`wls_domains_dir`](#wls_domains_dir)
* [`wls_apps_dir`](#wls_apps_dir)
* [`fmw_infra`](#fmw_infra)
* [`jdk_home_dir`](#jdk_home_dir)
* [`os_user`](#os_user)
* [`os_group`](#os_group)
* [`download_dir`](#download_dir)
* [`source`](#source)
* [`java_parameters`](#java_parameters)
* [`temp_directory`](#temp_directory)
* [`logoutput`](#logoutput)
* [`cleanup`](#cleanup)
* [`oracle_inventory_dir`](#oracle_inventory_dir)

##### <a name="version"></a>`version`

Data type: `Wls_install::Versions`

The version that is installed in the used Oracle home.
Puppet uses this value to decide on version specific actions.

Default value: `1111`

##### <a name="filename"></a>`filename`

Data type: `String[1]`

The source file to use.

Default value: ``undef``

##### <a name="oracle_base_home_dir"></a>`oracle_base_home_dir`

Data type: `Stdlib::Absolutepath`

A directory to use as Oracle base directory.

Default value: ``undef``

##### <a name="middleware_home_dir"></a>`middleware_home_dir`

Data type: `Stdlib::Absolutepath`

Middleware home directory.

Default value: ``undef``

##### <a name="weblogic_home_dir"></a>`weblogic_home_dir`

Data type: `Optional[Stdlib::Absolutepath]`

Directory to use as WebLogic home.

Default value: ``undef``

##### <a name="wls_domains_dir"></a>`wls_domains_dir`

Data type: `Optional[Stdlib::Absolutepath]`

The root directory where all domain directories reside in.

Default value: ``undef``

##### <a name="wls_apps_dir"></a>`wls_apps_dir`

Data type: `Optional[Stdlib::Absolutepath]`

The root directory where all aplication directories reside in.

Default value: ``undef``

##### <a name="fmw_infra"></a>`fmw_infra`

Data type: `Boolean`

Determine if you want to install Fusion Middleware infra.

Default value: ``false``

##### <a name="jdk_home_dir"></a>`jdk_home_dir`

Data type: `Stdlib::Absolutepath`

The homdirectory for the Java evelopment Kit.

Default value: ``undef``

##### <a name="os_user"></a>`os_user`

Data type: `String[1]`

The os user used to install and run WebLogic.

Default value: ``undef``

##### <a name="os_group"></a>`os_group`

Data type: `String[1]`

The os group used to install and run WebLogic.

Default value: ``undef``

##### <a name="download_dir"></a>`download_dir`

Data type: `Stdlib::Absolutepath`

The directory where the Puppet software puts all downloaded files.
Before Puppet can actually use remote files, they must be downloaded first. Puppet uses this directory to put all files in.
The default value is: `/install`

Default value: ``undef``

##### <a name="source"></a>`source`

Data type: `String[1]`

Source for the operation.

Default value: ``undef``

##### <a name="java_parameters"></a>`java_parameters`

Data type: `Optional[String]`

The (extra) parameters to pass when calling java.

Default value: `''`

##### <a name="temp_directory"></a>`temp_directory`

Data type: `Stdlib::Absolutepath`

Directory to use for temporary files.

Default value: `'/tmp'`

##### <a name="logoutput"></a>`logoutput`

Data type: `Variant[
    Boolean,
    Enum[
      'on_failure'
    ]
  ]`

log the outputs of Puppet exec or not.
When you specify `true` Puppet will log all output of `exec` types.
Valid values are:
- `true`
- `false`
- `on_failure`

Default value: `lookup({name => 'logoutput', default_value => 'on_failure'})`

##### <a name="cleanup"></a>`cleanup`

Data type: `Boolean`



Default value: ``false``

##### <a name="oracle_inventory_dir"></a>`oracle_inventory_dir`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: ``undef``

### <a name="wls_installstoreuserconfig"></a>`wls_install::storeuserconfig`

wls_install::storeuserconfig

Here is an example on how you could use this:

```puppet
ora_install::storeuserconfig{'Wls12c':
  domain_name                => "Wls12c",
  adminserver_address        => "localhost",
  adminserver_port           => 7001,
  weblogic_password          => "weblogic1",
  user_config_dir            => '/home/oracle',
  logoutput                 => false,
}
```

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `wls_install::storeuserconfig` defined type:

* [`domain_name`](#domain_name)
* [`weblogic_home_dir`](#weblogic_home_dir)
* [`jdk_home_dir`](#jdk_home_dir)
* [`adminserver_address`](#adminserver_address)
* [`adminserver_port`](#adminserver_port)
* [`user_config_dir`](#user_config_dir)
* [`weblogic_user`](#weblogic_user)
* [`weblogic_password`](#weblogic_password)
* [`os_user`](#os_user)
* [`os_group`](#os_group)
* [`download_dir`](#download_dir)
* [`logoutput`](#logoutput)

##### <a name="domain_name"></a>`domain_name`

Data type: `String[1]`

The domain name.

Default value: `lookup({name => 'domain_name'})`

##### <a name="weblogic_home_dir"></a>`weblogic_home_dir`

Data type: `Stdlib::Absolutepath`

Directory to use as WebLogic home.

Default value: `lookup({name => 'wls_weblogic_home_dir'})`

##### <a name="jdk_home_dir"></a>`jdk_home_dir`

Data type: `Stdlib::Absolutepath`

The homdirectory for the Java evelopment Kit.

Default value: `lookup({name => 'wls_jdk_home_dir'})`

##### <a name="adminserver_address"></a>`adminserver_address`

Data type: `String[1]`

The address of the admin server.
May be a DNS name or a physical IP address.

Default value: `lookup({name => 'domain_adminserver_address', default_value => 'localhost'})`

##### <a name="adminserver_port"></a>`adminserver_port`

Data type: `Integer`

The IP port the admin server is listening on.

Default value: `lookup({name => 'domain_adminserver_port', default_value => 7001})`

##### <a name="user_config_dir"></a>`user_config_dir`

Data type: `Stdlib::Absolutepath`

Directory where to store the user configs.

Default value: ``undef``

##### <a name="weblogic_user"></a>`weblogic_user`

Data type: `String[1]`

The base WebLogic username to configure.

Default value: `lookup({name => 'wls_weblogic_user', default_value => 'weblogic'})`

##### <a name="weblogic_password"></a>`weblogic_password`

Data type: `Easy_type::Password`

The password of the base WebLogic user name.

Default value: `lookup({name => 'domain_wls_password'})`

##### <a name="os_user"></a>`os_user`

Data type: `String[1]`

The os user used to install and run WebLogic.

Default value: `lookup({name => 'wls_os_user'})`

##### <a name="os_group"></a>`os_group`

Data type: `String[1]`

The os group used to install and run WebLogic.

Default value: `lookup({name => 'wls_os_group'})`

##### <a name="download_dir"></a>`download_dir`

Data type: `Stdlib::Absolutepath`

The directory where the Puppet software puts all downloaded files.
Before Puppet can actually use remote files, they must be downloaded first. Puppet uses this directory to put all files in.
The default value is: `/install`

Default value: `lookup({name => 'wls_download_dir'})`

##### <a name="logoutput"></a>`logoutput`

Data type: `Variant[
    Boolean,
    Enum[
      'on_failure'
    ]
  ]`

log the outputs of Puppet exec or not.
When you specify `true` Puppet will log all output of `exec` types.
Valid values are:
- `true`
- `false`
- `on_failure`

Default value: `lookup({name => 'logoutput', default_value => 'on_failure'})`

### <a name="wls_installsupportnodemanagerautostart"></a>`wls_install::support::nodemanagerautostart`

wls_install::support::nodemanagerautostart

This defined type allows you to add the nodemanager startup scripts to the system. Here is an example on how you could use this:```puppetora_install::support::nodemanagerautostart{"autostart ${wlsDomainName}":  version      => 1212,  wl_home      => '/opt/oracle/middleware12c/wlserver',  user         => 'oracle',  domain       => 'Wls1212',  domain_path  => '/opt/oracle/middleware12c/user_projects/domains/Wls1212'```

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `wls_install::support::nodemanagerautostart` defined type:

* [`version`](#version)
* [`wl_home`](#wl_home)
* [`user`](#user)
* [`domain`](#domain)
* [`domain_path`](#domain_path)
* [`log_dir`](#log_dir)
* [`jsse_enabled`](#jsse_enabled)
* [`custom_trust`](#custom_trust)
* [`trust_keystore_file`](#trust_keystore_file)
* [`trust_keystore_passphrase`](#trust_keystore_passphrase)
* [`systemd_script_location`](#systemd_script_location)

##### <a name="version"></a>`version`

Data type: `Wls_install::Versions`

The version that is installed in the used Oracle home.
Puppet uses this value to decide on version specific actions.

Default value: `1111`

##### <a name="wl_home"></a>`wl_home`

Data type: `Stdlib::Absolutepath`

WebLogic home directory.

Default value: ``undef``

##### <a name="user"></a>`user`

Data type: `String[1]`

The user used for the specified installation.
The install class will not create the user for you. You must do that yourself.
The default value is: `oracle`

Default value: `'oracle'`

##### <a name="domain"></a>`domain`

Data type: `String[1]`

Domain name.

Default value: ``undef``

##### <a name="domain_path"></a>`domain_path`

Data type: `String[1]`

Path where the domain inforrmation is stored.

Default value: ``undef``

##### <a name="log_dir"></a>`log_dir`

Data type: `Stdlib::Absolutepath`

Directory to use for logging.

Default value: ``undef``

##### <a name="jsse_enabled"></a>`jsse_enabled`

Data type: `Boolean`

Determine if you want to enable JSSE security.

Default value: ``false``

##### <a name="custom_trust"></a>`custom_trust`

Data type: `Boolean`

Determine if you want to use a custom trust or not.

Default value: ``false``

##### <a name="trust_keystore_file"></a>`trust_keystore_file`

Data type: `Optional[String[1]]`

File specificiation of the trust keystore.

Default value: ``undef``

##### <a name="trust_keystore_passphrase"></a>`trust_keystore_passphrase`

Data type: `Optional[Easy_type::Password]`

Passphrase to use for the trust keystore.

Default value: ``undef``

##### <a name="systemd_script_location"></a>`systemd_script_location`

Data type: `Optional[Stdlib::Absolutepath]`

Location to put the systemd script.

Default value: ``undef``

### <a name="wls_installutilsfmwcluster"></a>`wls_install::utils::fmwcluster`

wls_install::utils::fmwcluster

This will also work for OIM / OAM cluster. Here is an example on how you could use this:

```puppet
ora_install::fmwcluster { 'soaCluster':
  domain_name       => "soa_domain",
  soa_cluster_name  => "SoaCluster",
  bam_cluster_name  => "BamCluster",
  osb_cluster_name  => "OsbCluster",
  logoutput        => *logoutput,
  bpm_enabled       => true,
  bam_enabled       => true,
  soa_enabled       => true,
  osb_enabled       => true,
  repository_prefix => "DEV",
}
```

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `wls_install::utils::fmwcluster` defined type:

* [`version`](#version)
* [`ofm_version`](#ofm_version)
* [`weblogic_home_dir`](#weblogic_home_dir)
* [`middleware_home_dir`](#middleware_home_dir)
* [`jdk_home_dir`](#jdk_home_dir)
* [`wls_domains_dir`](#wls_domains_dir)
* [`domain_name`](#domain_name)
* [`adminserver_name`](#adminserver_name)
* [`adminserver_address`](#adminserver_address)
* [`adminserver_port`](#adminserver_port)
* [`nodemanager_port`](#nodemanager_port)
* [`soa_cluster_name`](#soa_cluster_name)
* [`bam_cluster_name`](#bam_cluster_name)
* [`osb_cluster_name`](#osb_cluster_name)
* [`oam_cluster_name`](#oam_cluster_name)
* [`oim_cluster_name`](#oim_cluster_name)
* [`ess_cluster_name`](#ess_cluster_name)
* [`bi_cluster_name`](#bi_cluster_name)
* [`bpm_enabled`](#bpm_enabled)
* [`bam_enabled`](#bam_enabled)
* [`osb_enabled`](#osb_enabled)
* [`soa_enabled`](#soa_enabled)
* [`oam_enabled`](#oam_enabled)
* [`oim_enabled`](#oim_enabled)
* [`b2b_enabled`](#b2b_enabled)
* [`ess_enabled`](#ess_enabled)
* [`bi_enabled`](#bi_enabled)
* [`repository_prefix`](#repository_prefix)
* [`weblogic_user`](#weblogic_user)
* [`weblogic_password`](#weblogic_password)
* [`os_user`](#os_user)
* [`os_group`](#os_group)
* [`download_dir`](#download_dir)
* [`retain_file_store`](#retain_file_store)
* [`jsse_enabled`](#jsse_enabled)
* [`custom_trust`](#custom_trust)
* [`trust_keystore_file`](#trust_keystore_file)
* [`trust_keystore_passphrase`](#trust_keystore_passphrase)
* [`nodemanager_secure_listener`](#nodemanager_secure_listener)
* [`logoutput`](#logoutput)

##### <a name="version"></a>`version`

Data type: `Wls_install::Versions`

The version that is installed in the used Oracle home.
Puppet uses this value to decide on version specific actions.

Default value: `lookup({name => 'wls_version', default_value => 1111})`

##### <a name="ofm_version"></a>`ofm_version`

Data type: `Variant[
    Integer[1116,1116],
    Integer[1117,1117]
  ]`

Version of OFM to use.

Default value: `lookup({name => 'ofm_version', default_value => 1117})`

##### <a name="weblogic_home_dir"></a>`weblogic_home_dir`

Data type: `Stdlib::Absolutepath`

Directory to use as WebLogic home.

Default value: `lookup({name => 'wls_weblogic_home_dir'})`

##### <a name="middleware_home_dir"></a>`middleware_home_dir`

Data type: `Stdlib::Absolutepath`

Middleware home directory.

Default value: `lookup({name => 'wls_middleware_home_dir'})`

##### <a name="jdk_home_dir"></a>`jdk_home_dir`

Data type: `Stdlib::Absolutepath`

The homdirectory for the Java evelopment Kit.

Default value: `lookup({name => 'wls_jdk_home_dir'})`

##### <a name="wls_domains_dir"></a>`wls_domains_dir`

Data type: `Stdlib::Absolutepath`

The root directory where all domain directories reside in.

Default value: `lookup({name => 'wls_domains_dir', default_value => undef})`

##### <a name="domain_name"></a>`domain_name`

Data type: `String[1]`

The domain name.

Default value: `lookup({name => 'domain_name'})`

##### <a name="adminserver_name"></a>`adminserver_name`

Data type: `String[1]`

The name of the Admin Server.

Default value: `lookup({name => 'domain_adminserver', default_value => 'AdminServer'})`

##### <a name="adminserver_address"></a>`adminserver_address`

Data type: `String[1]`

The address of the admin server.
May be a DNS name or a physical IP address.

Default value: `lookup({name => 'domain_adminserver_address', default_value => 'localhost'})`

##### <a name="adminserver_port"></a>`adminserver_port`

Data type: `Integer`

The IP port the admin server is listening on.

Default value: `lookup({name => 'domain_adminserver_port', default_value => 7001})`

##### <a name="nodemanager_port"></a>`nodemanager_port`

Data type: `Integer`

The IP port the nodemanager is listening on.

Default value: `lookup({name => 'domain_nodemanager_port', default_value => 5556})`

##### <a name="soa_cluster_name"></a>`soa_cluster_name`

Data type: `Optional[String[1]]`

Name of the cluster to target SOA managed servers on.

Default value: ``undef``

##### <a name="bam_cluster_name"></a>`bam_cluster_name`

Data type: `Optional[String[1]]`

Name of the cluster to target BAM managed servers on.

Default value: ``undef``

##### <a name="osb_cluster_name"></a>`osb_cluster_name`

Data type: `Optional[String[1]]`

Name of the cluster to target OSB managed servers on.

Default value: ``undef``

##### <a name="oam_cluster_name"></a>`oam_cluster_name`

Data type: `Optional[String[1]]`

Name of the cluster to target OAM managed servers on.

Default value: ``undef``

##### <a name="oim_cluster_name"></a>`oim_cluster_name`

Data type: `Optional[String[1]]`

Name of the cluster to target OIM managed servers on.

Default value: ``undef``

##### <a name="ess_cluster_name"></a>`ess_cluster_name`

Data type: `Optional[String[1]]`

Name of the cluster to target ESS managed servers on.

Default value: ``undef``

##### <a name="bi_cluster_name"></a>`bi_cluster_name`

Data type: `Optional[String[1]]`

Name of the cluster to target BI managed servers on.

Default value: ``undef``

##### <a name="bpm_enabled"></a>`bpm_enabled`

Data type: `Boolean`

Boolean to determine if bpm is enabled.

Default value: ``false``

##### <a name="bam_enabled"></a>`bam_enabled`

Data type: `Boolean`

Boolean to determine if bam is enabled.

Default value: ``false``

##### <a name="osb_enabled"></a>`osb_enabled`

Data type: `Boolean`

Boolean to determine if osb is enabled.

Default value: ``false``

##### <a name="soa_enabled"></a>`soa_enabled`

Data type: `Boolean`

Boolean to determine if soa is enabled.

Default value: ``false``

##### <a name="oam_enabled"></a>`oam_enabled`

Data type: `Boolean`

Boolean to determine if oam is enabled.

Default value: ``false``

##### <a name="oim_enabled"></a>`oim_enabled`

Data type: `Boolean`

Boolean to determine if oim is enabled.

Default value: ``false``

##### <a name="b2b_enabled"></a>`b2b_enabled`

Data type: `Boolean`

Boolean to determine if b2b is enabled.

Default value: ``false``

##### <a name="ess_enabled"></a>`ess_enabled`

Data type: `Boolean`

Boolean to determine if ess is enabled.

Default value: ``false``

##### <a name="bi_enabled"></a>`bi_enabled`

Data type: `Boolean`

Boolean to determine if bi is enabled.

Default value: ``false``

##### <a name="repository_prefix"></a>`repository_prefix`

Data type: `String[1]`

Extra prefix to use for the RCU.

Default value: `lookup({name => 'repository_prefix', default_value => 'DEV'})`

##### <a name="weblogic_user"></a>`weblogic_user`

Data type: `String[1]`

The base WebLogic username to configure.

Default value: `lookup({name => 'wls_weblogic_user', default_value => 'weblogic'})`

##### <a name="weblogic_password"></a>`weblogic_password`

Data type: `Easy_type::Password`

The password of the base WebLogic user name.

Default value: `lookup({name => 'domain_wls_password'})`

##### <a name="os_user"></a>`os_user`

Data type: `String[1]`

The os user used to install and run WebLogic.

Default value: `lookup({name => 'wls_os_user'})`

##### <a name="os_group"></a>`os_group`

Data type: `String[1]`

The os group used to install and run WebLogic.

Default value: `lookup({name => 'wls_os_group'})`

##### <a name="download_dir"></a>`download_dir`

Data type: `Stdlib::Absolutepath`

The directory where the Puppet software puts all downloaded files.
Before Puppet can actually use remote files, they must be downloaded first. Puppet uses this directory to put all files in.
The default value is: `/install`

Default value: `lookup({name => 'wls_download_dir'})`

##### <a name="retain_file_store"></a>`retain_file_store`

Data type: `Boolean`

Boolean to determine if you want to retain the security file store.
This is useful only for soa suite 1036 or 1111 and not if OAM is already installed.

Default value: `lookup({name => 'retain_security_file_store', default_value => false})`

##### <a name="jsse_enabled"></a>`jsse_enabled`

Data type: `Boolean`

Determine if you want to enable JSSE security.

Default value: `lookup({name => 'wls_jsse_enabled', default_value => false})`

##### <a name="custom_trust"></a>`custom_trust`

Data type: `Boolean`

Determine if you want to use a custom trust or not.

Default value: `lookup({name => 'wls_custom_trust', default_value => false})`

##### <a name="trust_keystore_file"></a>`trust_keystore_file`

Data type: `Optional[String[1]]`

File specificiation of the trust keystore.

Default value: `lookup({name => 'wls_trust_keystore_file', default_value => undef})`

##### <a name="trust_keystore_passphrase"></a>`trust_keystore_passphrase`

Data type: `Optional[Easy_type::Password]`

Passphrase to use for the trust keystore.

Default value: `lookup({name => 'wls_trust_keystore_passphrase', default_value => undef})`

##### <a name="nodemanager_secure_listener"></a>`nodemanager_secure_listener`

Data type: `Boolean`

Use SSL for listening.

Default value: ``true``

##### <a name="logoutput"></a>`logoutput`

Data type: `Variant[
    Boolean,
    Enum[
      'on_failure'
    ]
  ]`

log the outputs of Puppet exec or not.
When you specify `true` Puppet will log all output of `exec` types.
Valid values are:
- `true`
- `false`
- `on_failure`

Default value: `lookup({name => 'logoutput', default_value => 'on_failure'})`

### <a name="wls_installutilsfmwclusterjrf"></a>`wls_install::utils::fmwclusterjrf`

wls_install::utils::fmwclusterjrf

Here is an example on how you could use this:

```
ora_install::utils::fmwclusterjrf { 'WebCluster':
  domain_name          => "adf_domain",
  jrf_target_name      => "WebCluster",
  opss_datasource_name => "opss-data-source",
}

```

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `wls_install::utils::fmwclusterjrf` defined type:

* [`version`](#version)
* [`weblogic_home_dir`](#weblogic_home_dir)
* [`middleware_home_dir`](#middleware_home_dir)
* [`jdk_home_dir`](#jdk_home_dir)
* [`domain_name`](#domain_name)
* [`wls_domains_dir`](#wls_domains_dir)
* [`adminserver_name`](#adminserver_name)
* [`adminserver_address`](#adminserver_address)
* [`adminserver_port`](#adminserver_port)
* [`nodemanager_port`](#nodemanager_port)
* [`jrf_target_name`](#jrf_target_name)
* [`opss_datasource_name`](#opss_datasource_name)
* [`weblogic_user`](#weblogic_user)
* [`weblogic_password`](#weblogic_password)
* [`os_user`](#os_user)
* [`os_group`](#os_group)
* [`download_dir`](#download_dir)
* [`logoutput`](#logoutput)

##### <a name="version"></a>`version`

Data type: `Wls_install::Versions`

The version that is installed in the used Oracle home.
Puppet uses this value to decide on version specific actions.

Default value: `lookup({name => 'wls_version', default_value => 1111})`

##### <a name="weblogic_home_dir"></a>`weblogic_home_dir`

Data type: `Stdlib::Absolutepath`

Directory to use as WebLogic home.

Default value: `lookup({name => 'wls_weblogic_home_dir'})`

##### <a name="middleware_home_dir"></a>`middleware_home_dir`

Data type: `Stdlib::Absolutepath`

Middleware home directory.

Default value: `lookup({name => 'wls_middleware_home_dir'})`

##### <a name="jdk_home_dir"></a>`jdk_home_dir`

Data type: `Stdlib::Absolutepath`

The homdirectory for the Java evelopment Kit.

Default value: `lookup({name => 'wls_jdk_home_dir'})`

##### <a name="domain_name"></a>`domain_name`

Data type: `String[1]`

The domain name.

Default value: `lookup({name => 'domain_name'})`

##### <a name="wls_domains_dir"></a>`wls_domains_dir`

Data type: `Stdlib::Absolutepath`

The root directory where all domain directories reside in.

Default value: `lookup({name => 'wls_domains_dir', default_value => undef})`

##### <a name="adminserver_name"></a>`adminserver_name`

Data type: `String[1]`

The name of the Admin Server.

Default value: `lookup({name => 'domain_adminserver', default_value => 'AdminServer'})`

##### <a name="adminserver_address"></a>`adminserver_address`

Data type: `String[1]`

The address of the admin server.
May be a DNS name or a physical IP address.

Default value: `lookup({name => 'domain_adminserver_address', default_value => 'localhost'})`

##### <a name="adminserver_port"></a>`adminserver_port`

Data type: `Integer`

The IP port the admin server is listening on.

Default value: `lookup({name => 'domain_adminserver_port', default_value => 7001})`

##### <a name="nodemanager_port"></a>`nodemanager_port`

Data type: `Integer`

The IP port the nodemanager is listening on.

Default value: `lookup({name => 'domain_nodemanager_port', default_value => 5556})`

##### <a name="jrf_target_name"></a>`jrf_target_name`

Data type: `String[1]`

Target to use for JRF objects.

Default value: ``undef``

##### <a name="opss_datasource_name"></a>`opss_datasource_name`

Data type: `String[1]`

Datasource to use OPSS.

Default value: ``undef``

##### <a name="weblogic_user"></a>`weblogic_user`

Data type: `String[1]`

The base WebLogic username to configure.

Default value: `lookup({name => 'wls_weblogic_user', default_value => 'weblogic'})`

##### <a name="weblogic_password"></a>`weblogic_password`

Data type: `Easy_type::Password`

The password of the base WebLogic user name.

Default value: `lookup({name => 'domain_wls_password'})`

##### <a name="os_user"></a>`os_user`

Data type: `String[1]`

The os user used to install and run WebLogic.

Default value: `lookup({name => 'wls_os_user'})`

##### <a name="os_group"></a>`os_group`

Data type: `String[1]`

The os group used to install and run WebLogic.

Default value: `lookup({name => 'wls_os_group'})`

##### <a name="download_dir"></a>`download_dir`

Data type: `Stdlib::Absolutepath`

The directory where the Puppet software puts all downloaded files.
Before Puppet can actually use remote files, they must be downloaded first. Puppet uses this directory to put all files in.
The default value is: `/install`

Default value: `lookup({name => 'wls_download_dir'})`

##### <a name="logoutput"></a>`logoutput`

Data type: `Variant[
    Boolean,
    Enum[
      'on_failure'
    ]
  ]`

log the outputs of Puppet exec or not.
When you specify `true` Puppet will log all output of `exec` types.
Valid values are:
- `true`
- `false`
- `on_failure`

Default value: `lookup({name => 'logoutput', default_value => 'on_failure'})`

### <a name="wls_installutilsforms11gpatch"></a>`wls_install::utils::forms11gpatch`

wls_install::utils::forms11gpatch

Here is an example on how to use it:

``` puppet
}
```

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `wls_install::utils::forms11gpatch` defined type:

* [`version`](#version)
* [`weblogic_home_dir`](#weblogic_home_dir)
* [`middleware_home_dir`](#middleware_home_dir)
* [`oracle_base_home_dir`](#oracle_base_home_dir)
* [`oracle_home_dir`](#oracle_home_dir)
* [`jdk_home_dir`](#jdk_home_dir)
* [`fmw_file1`](#fmw_file1)
* [`os_user`](#os_user)
* [`os_group`](#os_group)
* [`download_dir`](#download_dir)
* [`source`](#source)
* [`temp_directory`](#temp_directory)
* [`logoutput`](#logoutput)

##### <a name="version"></a>`version`

Data type: `Wls_install::Versions`

The version that is installed in the used Oracle home.
Puppet uses this value to decide on version specific actions.

Default value: `lookup({name => 'wls_version', default_value => 1111})`

##### <a name="weblogic_home_dir"></a>`weblogic_home_dir`

Data type: `Stdlib::Absolutepath`

Directory to use as WebLogic home.

Default value: `lookup({name => 'wls_weblogic_home_dir'})`

##### <a name="middleware_home_dir"></a>`middleware_home_dir`

Data type: `Stdlib::Absolutepath`

Middleware home directory.

Default value: `lookup({name => 'wls_middleware_home_dir'})`

##### <a name="oracle_base_home_dir"></a>`oracle_base_home_dir`

Data type: `Stdlib::Absolutepath`

A directory to use as Oracle base directory.

Default value: `lookup({name => 'wls_oracle_base_home_dir'})`

##### <a name="oracle_home_dir"></a>`oracle_home_dir`

Data type: `Stdlib::Absolutepath`

A directory to be used as Oracle home directory for this software.

Default value: ``undef``

##### <a name="jdk_home_dir"></a>`jdk_home_dir`

Data type: `Stdlib::Absolutepath`

The homdirectory for the Java evelopment Kit.

Default value: `lookup({name => 'wls_jdk_home_dir'})`

##### <a name="fmw_file1"></a>`fmw_file1`

Data type: `String[1]`

First file of FMW distribution.

Default value: ``undef``

##### <a name="os_user"></a>`os_user`

Data type: `String[1]`

The os user used to install and run WebLogic.

Default value: `lookup({name => 'wls_os_user'})`

##### <a name="os_group"></a>`os_group`

Data type: `String[1]`

The os group used to install and run WebLogic.

Default value: `lookup({name => 'wls_os_group'})`

##### <a name="download_dir"></a>`download_dir`

Data type: `Stdlib::Absolutepath`

The directory where the Puppet software puts all downloaded files.
Before Puppet can actually use remote files, they must be downloaded first. Puppet uses this directory to put all files in.
The default value is: `/install`

Default value: `lookup({name => 'wls_download_dir'})`

##### <a name="source"></a>`source`

Data type: `String[1]`

Source for the operation.

Default value: `lookup({name => 'wls_source', default_value => undef})`

##### <a name="temp_directory"></a>`temp_directory`

Data type: `Stdlib::Absolutepath`

Directory to use for temporary files.

Default value: `lookup({name => 'wls_temp_dir', default_value => '/tmp'})`

##### <a name="logoutput"></a>`logoutput`

Data type: `Variant[
    Boolean,
    Enum[
      'on_failure'
    ]
  ]`

log the outputs of Puppet exec or not.
When you specify `true` Puppet will log all output of `exec` types.
Valid values are:
- `true`
- `false`
- `on_failure`

Default value: `lookup({name => 'logoutput', default_value => 'on_failure'})`

### <a name="wls_installutilsoimconfig"></a>`wls_install::utils::oimconfig`

wls_install::utils::oimconfig

This defined type allows you to configure OIM , oim server, design or remote configuration. Here is an example on how you could use this:```ora_install::utils::oimconfig{ 'oimDomain':  version                 => 1112,  oim_home                => '/opt/oracle/middleware11g/Oracle_IDM1',  server_config           => true,  oim_password            => 'Welcome01',  remote_config           => false,  keystore_password       => 'Welcome01',  design_config           => false,  oimserver_hostname      => 'oim1admin.example.com',  oimserver_port          => '14000',  repository_database_url => "oimdb.example.com:1521:oimrepos.example.com",  repository_prefix       => "DEV",  repository_password     => "Welcome01",}```

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `wls_install::utils::oimconfig` defined type:

* [`version`](#version)
* [`oim_home`](#oim_home)
* [`server_config`](#server_config)
* [`oim_password`](#oim_password)
* [`remote_config`](#remote_config)
* [`keystore_password`](#keystore_password)
* [`design_config`](#design_config)
* [`oimserver_hostname`](#oimserver_hostname)
* [`oimserver_port`](#oimserver_port)
* [`soaserver_name`](#soaserver_name)
* [`oimserver_name`](#oimserver_name)
* [`bi_enabled`](#bi_enabled)
* [`bi_cluster_name`](#bi_cluster_name)
* [`repository_database_url`](#repository_database_url)
* [`repository_prefix`](#repository_prefix)
* [`repository_password`](#repository_password)
* [`jdk_home_dir`](#jdk_home_dir)
* [`weblogic_home_dir`](#weblogic_home_dir)
* [`middleware_home_dir`](#middleware_home_dir)
* [`wls_domains_dir`](#wls_domains_dir)
* [`domain_name`](#domain_name)
* [`adminserver_name`](#adminserver_name)
* [`adminserver_address`](#adminserver_address)
* [`adminserver_port`](#adminserver_port)
* [`nodemanager_port`](#nodemanager_port)
* [`weblogic_user`](#weblogic_user)
* [`weblogic_password`](#weblogic_password)
* [`os_user`](#os_user)
* [`os_group`](#os_group)
* [`download_dir`](#download_dir)
* [`logoutput`](#logoutput)

##### <a name="version"></a>`version`

Data type: `Wls_install::Versions`

The version that is installed in the used Oracle home.
Puppet uses this value to decide on version specific actions.

Default value: ``undef``

##### <a name="oim_home"></a>`oim_home`

Data type: `Stdlib::Absolutepath`

Directory to contain the OIM home.

Default value: ``undef``

##### <a name="server_config"></a>`server_config`

Data type: `Boolean`



Default value: ``false``

##### <a name="oim_password"></a>`oim_password`

Data type: `Easy_type::Password`

OIM password.

Default value: ``undef``

##### <a name="remote_config"></a>`remote_config`

Data type: `Boolean`



Default value: ``false``

##### <a name="keystore_password"></a>`keystore_password`

Data type: `Easy_type::Password`

Password to use when opening the keystore.

Default value: ``undef``

##### <a name="design_config"></a>`design_config`

Data type: `Boolean`

Boolean to determine if you want to config oim design.

Default value: ``false``

##### <a name="oimserver_hostname"></a>`oimserver_hostname`

Data type: `String[1]`

Hostname for the oimserver.

Default value: ``undef``

##### <a name="oimserver_port"></a>`oimserver_port`

Data type: `Integer`

IP port for the OIM server.

Default value: `14000`

##### <a name="soaserver_name"></a>`soaserver_name`

Data type: `String[1]`

Name of the SOA server.

Default value: `'soa_server1'`

##### <a name="oimserver_name"></a>`oimserver_name`

Data type: `String[1]`

Name to use for the OIM server.

Default value: `'oim_server1'`

##### <a name="bi_enabled"></a>`bi_enabled`

Data type: `Boolean`

Boolean to determine if you want BI enabled.

Default value: ``false``

##### <a name="bi_cluster_name"></a>`bi_cluster_name`

Data type: `Optional[String[1]]`

Cluster where BI is running.

Default value: ``undef``

##### <a name="repository_database_url"></a>`repository_database_url`

Data type: `Optional[String[1]]`

The jdbc URL of the RCU repository.

Default value: `lookup({name => 'repository_database_url', default_value => undef})`

##### <a name="repository_prefix"></a>`repository_prefix`

Data type: `String[1]`

Extra prefix to use for the RCU.

Default value: `lookup({name => 'repository_prefix', default_value => 'DEV'})`

##### <a name="repository_password"></a>`repository_password`

Data type: `Easy_type::Password`

The password to use for accessing the RCU repository.

Default value: `lookup({name => 'repository_password', default_value => 'Welcome01'})`

##### <a name="jdk_home_dir"></a>`jdk_home_dir`

Data type: `Stdlib::Absolutepath`

The homdirectory for the Java evelopment Kit.

Default value: `lookup({name => 'wls_jdk_home_dir'})`

##### <a name="weblogic_home_dir"></a>`weblogic_home_dir`

Data type: `Stdlib::Absolutepath`

Directory to use as WebLogic home.

Default value: `lookup({name => 'wls_weblogic_home_dir'})`

##### <a name="middleware_home_dir"></a>`middleware_home_dir`

Data type: `Stdlib::Absolutepath`

Middleware home directory.

Default value: `lookup({name => 'wls_middleware_home_dir'})`

##### <a name="wls_domains_dir"></a>`wls_domains_dir`

Data type: `Stdlib::Absolutepath`

The root directory where all domain directories reside in.

Default value: `lookup({name => 'wls_domains_dir', default_value => undef})`

##### <a name="domain_name"></a>`domain_name`

Data type: `String[1]`

The domain name.

Default value: `lookup({name => 'domain_name'})`

##### <a name="adminserver_name"></a>`adminserver_name`

Data type: `String[1]`

The name of the Admin Server.

Default value: `lookup({name => 'domain_adminserver', default_value => 'AdminServer'})`

##### <a name="adminserver_address"></a>`adminserver_address`

Data type: `String[1]`

The address of the admin server.
May be a DNS name or a physical IP address.

Default value: `lookup({name => 'domain_adminserver_address', default_value => 'localhost'})`

##### <a name="adminserver_port"></a>`adminserver_port`

Data type: `Integer`

The IP port the admin server is listening on.

Default value: `lookup({name => 'domain_adminserver_port', default_value => 7001})`

##### <a name="nodemanager_port"></a>`nodemanager_port`

Data type: `Integer`

The IP port the nodemanager is listening on.

Default value: `lookup({name => 'domain_nodemanager_port', default_value => 5556})`

##### <a name="weblogic_user"></a>`weblogic_user`

Data type: `String[1]`

The base WebLogic username to configure.

Default value: `lookup({name => 'wls_weblogic_user', default_value => 'weblogic'})`

##### <a name="weblogic_password"></a>`weblogic_password`

Data type: `Easy_Type::Password`

The password of the base WebLogic user name.

Default value: `lookup({name => 'domain_wls_password'})`

##### <a name="os_user"></a>`os_user`

Data type: `String[1]`

The os user used to install and run WebLogic.

Default value: `lookup({name => 'wls_os_user'})`

##### <a name="os_group"></a>`os_group`

Data type: `String[1]`

The os group used to install and run WebLogic.

Default value: `lookup({name => 'wls_os_group'})`

##### <a name="download_dir"></a>`download_dir`

Data type: `Stdlib::Absolutepath`

The directory where the Puppet software puts all downloaded files.
Before Puppet can actually use remote files, they must be downloaded first. Puppet uses this directory to put all files in.
The default value is: `/install`

Default value: `lookup({name => 'wls_download_dir'})`

##### <a name="logoutput"></a>`logoutput`

Data type: `Variant[
    Boolean,
    Enum[
      'on_failure'
    ]
  ]`

log the outputs of Puppet exec or not.
When you specify `true` Puppet will log all output of `exec` types.
Valid values are:
- `true`
- `false`
- `on_failure`

Default value: `lookup({name => 'logoutput', default_value => 'on_failure'})`

### <a name="wls_installutilsorainst"></a>`wls_install::utils::orainst`

See the file "LICENSE" for the full license governing this code.

== define: wls_install::utils::orainst

 creates oraInst.loc for oracle products

#### Parameters

The following parameters are available in the `wls_install::utils::orainst` defined type:

* [`ora_inventory_dir`](#ora_inventory_dir)
* [`os_group`](#os_group)

##### <a name="ora_inventory_dir"></a>`ora_inventory_dir`

Data type: `Stdlib::Absolutepath`



Default value: ``undef``

##### <a name="os_group"></a>`os_group`

Data type: `String[1]`



Default value: ``undef``

### <a name="wls_installutilsprivateold_servers_removed"></a>`wls_install::utils::private::old_servers_removed`

See the file "LICENSE" for the full license governing this code.


This defined type removes all directoryes in the domain that once
belonged to the default servers created by the fusion installers.

#### Parameters

The following parameters are available in the `wls_install::utils::private::old_servers_removed` defined type:

* [`bam_enabled`](#bam_enabled)
* [`osb_enabled`](#osb_enabled)
* [`soa_enabled`](#soa_enabled)
* [`ess_enabled`](#ess_enabled)

##### <a name="bam_enabled"></a>`bam_enabled`

Data type: `Boolean`



Default value: ``false``

##### <a name="osb_enabled"></a>`osb_enabled`

Data type: `Boolean`



Default value: ``false``

##### <a name="soa_enabled"></a>`soa_enabled`

Data type: `Boolean`



Default value: ``false``

##### <a name="ess_enabled"></a>`ess_enabled`

Data type: `Boolean`



Default value: ``false``

### <a name="wls_installutilsrcu"></a>`wls_install::utils::rcu`

wls_install::utils::rcu

Don't use direct.

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `wls_install::utils::rcu` defined type:

* [`version`](#version)
* [`fmw_product`](#fmw_product)
* [`oracle_fmw_product_home_dir`](#oracle_fmw_product_home_dir)
* [`jdk_home_dir`](#jdk_home_dir)
* [`os_user`](#os_user)
* [`os_group`](#os_group)
* [`download_dir`](#download_dir)
* [`rcu_action`](#rcu_action)
* [`rcu_jdbc_url`](#rcu_jdbc_url)
* [`rcu_database_url`](#rcu_database_url)
* [`rcu_prefix`](#rcu_prefix)
* [`rcu_password`](#rcu_password)
* [`rcu_sys_user`](#rcu_sys_user)
* [`rcu_sys_password`](#rcu_sys_password)
* [`rcu_honor_omf`](#rcu_honor_omf)
* [`rcu_soa_profile`](#rcu_soa_profile)
* [`rcu_tablespace`](#rcu_tablespace)
* [`rcu_temp_tablespace`](#rcu_temp_tablespace)
* [`logoutput`](#logoutput)

##### <a name="version"></a>`version`

Data type: `Wls_install::Versions`

The version that is installed in the used Oracle home.
Puppet uses this value to decide on version specific actions.

Default value: `lookup({name => 'wls_version', default_value => 1111})`

##### <a name="fmw_product"></a>`fmw_product`

Data type: `Enum['adf','soa','mft', 'forms','bip']`

Type of Fusion Middleware Product you want to install.
Valid values are:
- adf
- soa
- soaqs
- osb
- wcc
- wc
- oim
- oam
- web
- webgate
- oud
- mft
- b2b
- forms

Default value: `'adf'`

##### <a name="oracle_fmw_product_home_dir"></a>`oracle_fmw_product_home_dir`

Data type: `Stdlib::Absolutepath`

Fusion Middleware home.

Default value: ``undef``

##### <a name="jdk_home_dir"></a>`jdk_home_dir`

Data type: `Stdlib::Absolutepath`

The homdirectory for the Java evelopment Kit.

Default value: `lookup({name => 'wls_jdk_home_dir'})`

##### <a name="os_user"></a>`os_user`

Data type: `String[1]`

The os user used to install and run WebLogic.

Default value: `lookup({name => 'wls_os_user'})`

##### <a name="os_group"></a>`os_group`

Data type: `String[1]`

The os group used to install and run WebLogic.

Default value: `lookup({name => 'wls_os_group'})`

##### <a name="download_dir"></a>`download_dir`

Data type: `Stdlib::Absolutepath`

The directory where the Puppet software puts all downloaded files.
Before Puppet can actually use remote files, they must be downloaded first. Puppet uses this directory to put all files in.
The default value is: `/install`

Default value: `lookup({name => 'wls_download_dir'})`

##### <a name="rcu_action"></a>`rcu_action`

Data type: `Enum['create','delete']`

Action to perform.
Valid values are:
- create
- delete

Default value: `'create'`

##### <a name="rcu_jdbc_url"></a>`rcu_jdbc_url`

Data type: `Optional[String[1]]`

The jdbc URL of the RCU repository.

Default value: ``undef``

##### <a name="rcu_database_url"></a>`rcu_database_url`

Data type: `Optional[String[1]]`

Database URL to create the RCU on.

Default value: ``undef``

##### <a name="rcu_prefix"></a>`rcu_prefix`

Data type: `Optional[String[1]]`

Extra prefix to use for the RCU.

Default value: ``undef``

##### <a name="rcu_password"></a>`rcu_password`

Data type: `Easy_type::Password`

The password to use on the database where the RCU repository is created.

Default value: ``undef``

##### <a name="rcu_sys_user"></a>`rcu_sys_user`

Data type: `String[1]`

SYS username to use on the database where the RCU repository is created.
Default is 'SYS'

Default value: `'sys'`

##### <a name="rcu_sys_password"></a>`rcu_sys_password`

Data type: `Easy_type::Password`

SYS password to use on the database where the RCU repository is created.

Default value: ``undef``

##### <a name="rcu_honor_omf"></a>`rcu_honor_omf`

Data type: `Optional[Boolean]`

Boolean to determine if you want the RCU creation to honor OMF (Oracle Managed Files).

Default value: ``undef``

##### <a name="rcu_soa_profile"></a>`rcu_soa_profile`

Data type: `Optional[
    Enum[
      'SMALL',
      'MED',
      'LARGE'
    ]
  ]`

Profile to use for creating the RCU for SOA.

Default value: ``undef``

##### <a name="rcu_tablespace"></a>`rcu_tablespace`

Data type: `Optional[String[1]]`

The default tablespace to use for the RCU created accounts.

Default value: ``undef``

##### <a name="rcu_temp_tablespace"></a>`rcu_temp_tablespace`

Data type: `Optional[String[1]]`

The temporary tablespace to use for the RCU created accounts.

Default value: ``undef``

##### <a name="logoutput"></a>`logoutput`

Data type: `Variant[
    Boolean,
    Enum[
      'on_failure'
    ]
  ]`

log the outputs of Puppet exec or not.
When you specify `true` Puppet will log all output of `exec` types.
Valid values are:
- `true`
- `false`
- `on_failure`

Default value: `lookup({name => 'logoutput', default_value => 'on_failure'})`

### <a name="wls_installutilswebtier"></a>`wls_install::utils::webtier`

wls_install::utils::webtier

Here is an example on how you could use this:

```
ora_install::utils::webtier{ 'ohs1':
  action_name       => 'create',
  instance_name     => 'ohs1',
  webgate_configure => true,
}
```

See the file "LICENSE" for the full license governing this code.

#### Parameters

The following parameters are available in the `wls_install::utils::webtier` defined type:

* [`version`](#version)
* [`weblogic_home_dir`](#weblogic_home_dir)
* [`middleware_home_dir`](#middleware_home_dir)
* [`jdk_home_dir`](#jdk_home_dir)
* [`wls_domains_dir`](#wls_domains_dir)
* [`domain_name`](#domain_name)
* [`adminserver_address`](#adminserver_address)
* [`adminserver_port`](#adminserver_port)
* [`action_name`](#action_name)
* [`webgate_configure`](#webgate_configure)
* [`webgate_agentname`](#webgate_agentname)
* [`webgate_hostidentifier`](#webgate_hostidentifier)
* [`oamadminserverhostname`](#oamadminserverhostname)
* [`oamadminserverport`](#oamadminserverport)
* [`domain_configure`](#domain_configure)
* [`instance_name`](#instance_name)
* [`machine_name`](#machine_name)
* [`weblogic_user`](#weblogic_user)
* [`weblogic_password`](#weblogic_password)
* [`os_user`](#os_user)
* [`os_group`](#os_group)
* [`download_dir`](#download_dir)
* [`logoutput`](#logoutput)

##### <a name="version"></a>`version`

Data type: `Wls_install::Versions`

The version that is installed in the used Oracle home.
Puppet uses this value to decide on version specific actions.

Default value: `lookup({name => 'wls_version', default_value => 1111})`

##### <a name="weblogic_home_dir"></a>`weblogic_home_dir`

Data type: `Stdlib::Absolutepath`

Directory to use as WebLogic home.

Default value: `lookup({name => 'wls_weblogic_home_dir'})`

##### <a name="middleware_home_dir"></a>`middleware_home_dir`

Data type: `Stdlib::Absolutepath`

Middleware home directory.

Default value: `lookup({name => 'wls_middleware_home_dir'})`

##### <a name="jdk_home_dir"></a>`jdk_home_dir`

Data type: `Stdlib::Absolutepath`

The homdirectory for the Java evelopment Kit.

Default value: `lookup({name => 'wls_jdk_home_dir'})`

##### <a name="wls_domains_dir"></a>`wls_domains_dir`

Data type: `Stdlib::Absolutepath`

The root directory where all domain directories reside in.

Default value: `lookup({name => 'wls_domains_dir', default_value => undef})`

##### <a name="domain_name"></a>`domain_name`

Data type: `String[1]`

The domain name.

Default value: `lookup({name => 'domain_name'})`

##### <a name="adminserver_address"></a>`adminserver_address`

Data type: `String[1]`

The address of the admin server.
May be a DNS name or a physical IP address.

Default value: `lookup({name => 'domain_adminserver_address', default_value => 'localhost'})`

##### <a name="adminserver_port"></a>`adminserver_port`

Data type: `Integer`

The IP port the admin server is listening on.

Default value: `lookup({name => 'domain_adminserver_port', default_value => 7001})`

##### <a name="action_name"></a>`action_name`

Data type: `Enum['create','delete']`

Action to perform.
Valid values are:
- create
- delete

Default value: `'create'`

##### <a name="webgate_configure"></a>`webgate_configure`

Data type: `Boolean`



Default value: ``false``

##### <a name="webgate_agentname"></a>`webgate_agentname`

Data type: `Optional[String[1]]`



Default value: `lookup({name => 'webgate_agentname', default_value => undef})`

##### <a name="webgate_hostidentifier"></a>`webgate_hostidentifier`

Data type: `Optional[String[1]]`



Default value: `lookup({name => 'webgate_hostidentifier', default_value => undef})`

##### <a name="oamadminserverhostname"></a>`oamadminserverhostname`

Data type: `String[1]`



Default value: `lookup({name => 'oamadminserverhostname', default_value => 'localhost'})`

##### <a name="oamadminserverport"></a>`oamadminserverport`

Data type: `Integer`



Default value: `lookup({name => 'oamadminserverport', default_value => 7001})`

##### <a name="domain_configure"></a>`domain_configure`

Data type: `Boolean`



Default value: ``true``

##### <a name="instance_name"></a>`instance_name`

Data type: `Optional[String[1]]`



Default value: ``undef``

##### <a name="machine_name"></a>`machine_name`

Data type: `Optional[String[1]]`

Name of the weblogic machine to use.

Default value: ``undef``

##### <a name="weblogic_user"></a>`weblogic_user`

Data type: `String[1]`

The base WebLogic username to configure.

Default value: `lookup({name => 'wls_weblogic_user', default_value => 'weblogic'})`

##### <a name="weblogic_password"></a>`weblogic_password`

Data type: `Easy_type::Password`

The password of the base WebLogic user name.

Default value: `lookup({name => 'domain_wls_password'})`

##### <a name="os_user"></a>`os_user`

Data type: `String[1]`

The os user used to install and run WebLogic.

Default value: `lookup({name => 'wls_os_user'})`

##### <a name="os_group"></a>`os_group`

Data type: `String[1]`

The os group used to install and run WebLogic.

Default value: `lookup({name => 'wls_os_group'})`

##### <a name="download_dir"></a>`download_dir`

Data type: `Stdlib::Absolutepath`

The directory where the Puppet software puts all downloaded files.
Before Puppet can actually use remote files, they must be downloaded first. Puppet uses this directory to put all files in.
The default value is: `/install`

Default value: `lookup({name => 'wls_download_dir'})`

##### <a name="logoutput"></a>`logoutput`

Data type: `Variant[
    Boolean,
    Enum[
      'on_failure'
    ]
  ]`

log the outputs of Puppet exec or not.
When you specify `true` Puppet will log all output of `exec` types.
Valid values are:
- `true`
- `false`
- `on_failure`

Default value: `lookup({name => 'logoutput', default_value => 'on_failure'})`

## Resource types

### <a name="wls_adminserver"></a>`wls_adminserver`

control the adminserver state like running,stop,restart

#### Properties

The following properties are available in the `wls_adminserver` type.

##### `ensure`

Valid values: `start`, `stop`, `running`, `abort`

Aliases: `"running"=>"start", "abort"=>"stop"`

Whether to do something.

#### Parameters

The following parameters are available in the `wls_adminserver` type.

* [`custom_trust`](#custom_trust)
* [`domain_name`](#domain_name)
* [`domain_path`](#domain_path)
* [`jdk_home_dir`](#jdk_home_dir)
* [`jsse_enabled`](#jsse_enabled)
* [`name`](#name)
* [`nodemanager_address`](#nodemanager_address)
* [`nodemanager_port`](#nodemanager_port)
* [`nodemanager_secure_listener`](#nodemanager_secure_listener)
* [`ohs_standalone_server`](#ohs_standalone_server)
* [`os_user`](#os_user)
* [`provider`](#provider)
* [`refreshonly`](#refreshonly)
* [`server_name`](#server_name)
* [`trust_keystore_file`](#trust_keystore_file)
* [`trust_keystore_passphrase`](#trust_keystore_passphrase)
* [`weblogic_home_dir`](#weblogic_home_dir)
* [`weblogic_password`](#weblogic_password)
* [`weblogic_user`](#weblogic_user)

##### <a name="custom_trust"></a>`custom_trust`

Valid values: ``true``, ``false``

The custom trust enabled.

Default value: ``false``

##### <a name="domain_name"></a>`domain_name`

The weblogic domain name.

##### <a name="domain_path"></a>`domain_path`

The full domain path.

##### <a name="jdk_home_dir"></a>`jdk_home_dir`

The jdk home dir.

##### <a name="jsse_enabled"></a>`jsse_enabled`

Valid values: ``true``, ``false``

The jsse enabled.

Default value: ``false``

##### <a name="name"></a>`name`

namevar

The title.

##### <a name="nodemanager_address"></a>`nodemanager_address`

The nodemanager address.

##### <a name="nodemanager_port"></a>`nodemanager_port`

The nodemanager port.

##### <a name="nodemanager_secure_listener"></a>`nodemanager_secure_listener`

Valid values: ``true``, ``false``

The nodemanager secure listener true or false.

Default value: ``true``

##### <a name="ohs_standalone_server"></a>`ohs_standalone_server`

Valid values: ``true``, ``false``

Flag to determinate if the server is a OHS standalone server.

Default value: ``false``

##### <a name="os_user"></a>`os_user`

The weblogic operating system user.

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_adminserver` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

##### <a name="refreshonly"></a>`refreshonly`

Valid values: ``true``, ``false``

The command should only be run as a
refresh mechanism for when a dependent object is changed.

Default value: ``false``

##### <a name="server_name"></a>`server_name`

The adminserver name.

##### <a name="trust_keystore_file"></a>`trust_keystore_file`

The trust keystore full path.

##### <a name="trust_keystore_passphrase"></a>`trust_keystore_passphrase`

The trust keystore password.

##### <a name="weblogic_home_dir"></a>`weblogic_home_dir`

The weblogic home folder.

##### <a name="weblogic_password"></a>`weblogic_password`

The weblogic user password.

##### <a name="weblogic_user"></a>`weblogic_user`

The weblogic user.

### <a name="wls_directory_structure"></a>`wls_directory_structure`

add all the directories needed by the oracle weblogic installation

#### Properties

The following properties are available in the `wls_directory_structure` type.

##### `ensure`

Valid values: `present`

Whether to do something.

#### Parameters

The following parameters are available in the `wls_directory_structure` type.

* [`download_dir`](#download_dir)
* [`name`](#name)
* [`ora_inventory_dir`](#ora_inventory_dir)
* [`oracle_base_dir`](#oracle_base_dir)
* [`os_group`](#os_group)
* [`os_user`](#os_user)
* [`provider`](#provider)
* [`wls_apps_dir`](#wls_apps_dir)
* [`wls_domains_dir`](#wls_domains_dir)

##### <a name="download_dir"></a>`download_dir`

The download folder.

##### <a name="name"></a>`name`

namevar

The title.

##### <a name="ora_inventory_dir"></a>`ora_inventory_dir`

The oracle inventory folder.

##### <a name="oracle_base_dir"></a>`oracle_base_dir`

The oracle base folder.

##### <a name="os_group"></a>`os_group`

The weblogic operating system group.

Default value: `dba`

##### <a name="os_user"></a>`os_user`

The weblogic operating system user.

Default value: `oracle`

##### <a name="provider"></a>`provider`

The specific backend to use for this `wls_directory_structure` resource. You will seldom need to specify this --- Puppet
will usually discover the appropriate provider for your platform.

##### <a name="wls_apps_dir"></a>`wls_apps_dir`

The oracle weblogic apps folder.

##### <a name="wls_domains_dir"></a>`wls_domains_dir`

The oracle weblogic domains folder.

## Functions

### <a name="wls_installartifact_exists"></a>`wls_install::artifact_exists`

Type: Ruby 4.x API

This function checks if artifact exists in the specified location.


See the file "LICENSE" for the full license governing this code.

#### `wls_install::artifact_exists(String $domain_dir, String $type, String $wls_object, Optional[String] $sub_type)`

This function checks if artifact exists in the specified location.


See the file "LICENSE" for the full license governing this code.

Returns: `Boolean`

##### `domain_dir`

Data type: `String`



##### `type`

Data type: `String`



##### `wls_object`

Data type: `String`



##### `sub_type`

Data type: `Optional[String]`



### <a name="wls_installbam_cluster_configured"></a>`wls_install::bam_cluster_configured`

Type: Ruby 4.x API

This function checks if bam cluster is configured in the specified path.


See the file "LICENSE" for the full license governing this code.

#### `wls_install::bam_cluster_configured(String $domain_dir, String $bam_cluster_name)`

This function checks if bam cluster is configured in the specified path.


See the file "LICENSE" for the full license governing this code.

Returns: `Boolean`

##### `domain_dir`

Data type: `String`



##### `bam_cluster_name`

Data type: `String`



### <a name="wls_installdomain_exists"></a>`wls_install::domain_exists`

Type: Ruby 4.x API

This function checks if domain exists in the specified location.


See the file "LICENSE" for the full license governing this code.

#### `wls_install::domain_exists(String $domain_dir)`

This function checks if domain exists in the specified location.


See the file "LICENSE" for the full license governing this code.

Returns: `Boolean`

##### `domain_dir`

Data type: `String`



### <a name="wls_installfilter_unsupported_jvm_options"></a>`wls_install::filter_unsupported_jvm_options`

Type: Ruby 4.x API

This function filters unsupported jvm options.


See the file "LICENSE" for the full license governing this code.

#### `wls_install::filter_unsupported_jvm_options(String $jvm_options, Integer $jvm_version)`

This function filters unsupported jvm options.


See the file "LICENSE" for the full license governing this code.

Returns: `String`

##### `jvm_options`

Data type: `String`



##### `jvm_version`

Data type: `Integer`



### <a name="wls_installfmw_installed"></a>`wls_install::fmw_installed`

Type: Ruby 4.x API

Check if the Fusion Middleware product is already installed

#### `wls_install::fmw_installed(Stdlib::Absolutepath $oracle_home, Wls_install::Fmw_products $product)`

Check if the Fusion Middleware product is already installed

Returns: `Boolean`

##### `oracle_home`

Data type: `Stdlib::Absolutepath`



##### `product`

Data type: `Wls_install::Fmw_products`



### <a name="wls_installjrf_cluster_configured"></a>`wls_install::jrf_cluster_configured`

Type: Ruby 4.x API

This function checks if osb cluster is configured in the specified path.


See the file "LICENSE" for the full license governing this code.

#### `wls_install::jrf_cluster_configured(String $domain_dir, String $jrf_cluster_name)`

This function checks if osb cluster is configured in the specified path.


See the file "LICENSE" for the full license governing this code.

Returns: `Boolean`

##### `domain_dir`

Data type: `String`



##### `jrf_cluster_name`

Data type: `String`



### <a name="wls_installlog"></a>`wls_install::log`

Type: Ruby 4.x API

This function logs data from wls_install module.


See the file "LICENSE" for the full license governing this code.

#### `wls_install::log(Any $msg, Optional[Any] $level = :info)`

This function logs data from wls_install module.


See the file "LICENSE" for the full license governing this code.

Returns: `Any`

##### `msg`

Data type: `Any`



##### `level`

Data type: `Optional[Any]`



### <a name="wls_installoim_configured"></a>`wls_install::oim_configured`

Type: Ruby 4.x API

This function checks if oim is configured in the specified path.


See the file "LICENSE" for the full license governing this code.

#### `wls_install::oim_configured(String $domain_dir)`

This function checks if oim is configured in the specified path.


See the file "LICENSE" for the full license governing this code.

Returns: `Boolean`

##### `domain_dir`

Data type: `String`



### <a name="wls_installords_installed"></a>`wls_install::ords_installed`

Type: Ruby 4.x API

This function checks if ORDS is installed.


See the file "LICENSE" for the full license governing this code.

#### `wls_install::ords_installed(Stdlib::Absolutepath $home, String[1] $version)`

This function checks if ORDS is installed.


See the file "LICENSE" for the full license governing this code.

Returns: `Boolean`

##### `home`

Data type: `Stdlib::Absolutepath`



##### `version`

Data type: `String[1]`



### <a name="wls_installosb_cluster_configured"></a>`wls_install::osb_cluster_configured`

Type: Ruby 4.x API

This function checks if osb cluster is configured in the specified path.


See the file "LICENSE" for the full license governing this code.

#### `wls_install::osb_cluster_configured(String $domain_dir, String $osb_cluster_name)`

This function checks if osb cluster is configured in the specified path.


See the file "LICENSE" for the full license governing this code.

Returns: `Boolean`

##### `domain_dir`

Data type: `String`



##### `osb_cluster_name`

Data type: `String`



### <a name="wls_installrunning_domains"></a>`wls_install::running_domains`

Type: Ruby 4.x API

This function will return the domains currently running from a specific home.


See the file "LICENSE" for the full license governing this code.

#### `wls_install::running_domains(String[1] $home)`

This function will return the domains currently running from a specific home.


See the file "LICENSE" for the full license governing this code.

Returns: `Array`

##### `home`

Data type: `String[1]`



### <a name="wls_installsoa_cluster_configured"></a>`wls_install::soa_cluster_configured`

Type: Ruby 4.x API

This function checks if soa cluster is configured in the specified path.


See the file "LICENSE" for the full license governing this code.

#### `wls_install::soa_cluster_configured(String $domain_dir, String $soa_cluster_name)`

This function checks if soa cluster is configured in the specified path.


See the file "LICENSE" for the full license governing this code.

Returns: `Boolean`

##### `domain_dir`

Data type: `String`



##### `soa_cluster_name`

Data type: `String`



### <a name="wls_installweblogic_exists"></a>`wls_install::weblogic_exists`

Type: Ruby 4.x API

This function checks if WebLogic is installed.


See the file "LICENSE" for the full license governing this code.

#### `wls_install::weblogic_exists(String $name)`

This function checks if WebLogic is installed.


See the file "LICENSE" for the full license governing this code.

Returns: `Boolean`

##### `name`

Data type: `String`



### <a name="wls_installwls_patches_missing"></a>`wls_install::wls_patches_missing`

Type: Ruby 4.x API

This function checks if the specfied patches are installed.
And it will return a Hash with the oracle home(s) with patch details
that still needs at least one more patch

It will check all registered Oracle homes for the installed patches.


See the file "LICENSE" for the full license governing this code.

#### `wls_install::wls_patches_missing(Hash $patch_list)`

This function checks if the specfied patches are installed.
And it will return a Hash with the oracle home(s) with patch details
that still needs at least one more patch

It will check all registered Oracle homes for the installed patches.


See the file "LICENSE" for the full license governing this code.

Returns: `Hash`

##### `patch_list`

Data type: `Hash`



### <a name="wls_installwls_physical_patches"></a>`wls_install::wls_physical_patches`

Type: Ruby 4.x API

This function parses a Hash of patches and looks for resources with
sub_patches. If they are there, this function will translate it to the
actual list of patches that need to be on the system.


See the file "LICENSE" for the full license governing this code.

#### `wls_install::wls_physical_patches(Hash $patch_list)`

This function parses a Hash of patches and looks for resources with
sub_patches. If they are there, this function will translate it to the
actual list of patches that need to be on the system.


See the file "LICENSE" for the full license governing this code.

Returns: `Array`

##### `patch_list`

Data type: `Hash`



## Data types

### <a name="wls_installfmw_products"></a>`Wls_install::Fmw_products`

Installed fmw products.


See the file "LICENSE" for the full license governing this code.

Alias of

```puppet
Enum['adf', 'soa', 'soaqs', 'osb', 'wcc', 'wc', 'oim', 'oam', 'web', 'webgate', 'oud', 'mft', 'b2b', 'forms', 'bip']
```

### <a name="wls_installversions"></a>`Wls_install::Versions`

Versions of installed WebLogic software.


See the file "LICENSE" for the full license governing this code.

Alias of

```puppet
Variant[Integer[1036,1036], Integer[1111,1111], Integer[1112,1112], Integer[1211,1211], Integer[1212,1212], Integer[1213,1213], Integer[1221,1221], Integer[12211,12211], Integer[12212,12212], Integer[12213,12213], Integer[12214,12214], Integer[14110,14110]]
```

